/******************************************************************************
 * @file     	task_register.h
 * @brief     ʼע
 * @version   V1
 * @copyright
 ******************************************************************************/
#ifndef TASK_REGISTER_H_
#define TASK_REGISTER_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "drv_clk.h"
#include "drv_rtc.h"
#include "drv_misc.h"
#include "bsp_task.h"
#include "bsp_flash.h"
#include "bsp_number.h"
#include "iso_check.h"
#include "soc_calculate.h"
#include "sop_calculate.h"
#include "db_config.h"
#include "version_manager.h"
#include "adc_manager.h"
#include "bmu_manager.h"
#include "gpio_manager.h"
#include "comm_manager.h"
#include "dido_manager.h"
#include "fault_manager.h"
#include "signal_manager.h"
#include "hv_adc_manager.h"
#include "flash_manager.h"
#include "eeprom_manager.h"
#include "statistic_manager.h"
#include "run_status.h"

#include "logic_ctrl.h"
#include "protocol_comm.h"
#include "hv_adc_manager.h"
#include "ucos_ii.h"
#include "cpu_core.h"

#include "os_cpu.h"
#include "kit_debug.h"

//#include "bms_app.h"
#include "bmu_manager.h"
#include "bmu_adbms1818.h"
#include "protocol_comm.h"

typedef void (*SN_BMS_INIT_CALL)(uint32_t base_time);
int sn_bms_init(SN_BMS_INIT_CALL call);

/*****************************************************************************
 * @brief       жϻص
 * @param[in]   void: 
 * @return      void
 *****************************************************************************/
void ucos_irq_handler(void);



#ifdef __cplusplus
}
#endif

#endif
