#ifndef TABLE_COMM_H_
#define TABLE_COMM_H_
#ifdef __cplusplus
extern "C" {
#endif

#include "kit_table.h"

/********************************************SOP********************************************/
typedef enum
{
    kOcvTab_Default,
	kOcvTab_Cnte, //时代星云
	kOcvTab_End,
}SocTable;

typedef enum
{
    kSopTab_Rated,
	kSopTab_Cnte, //时代星云
	kSopTab_End,
}SopTable;

extern const ThreeDTabItem *ocv_table_list[kOcvTab_End];
extern const ThreeDTabItem *sop_table_list[kSopTab_End];

/********************************************NTC********************************************/
typedef enum
{
	kNtcType_Start,
    kNtcType_CWFH708_H713 = kNtcType_Start,         //APR-CWFH708_H713-CWF103F3435FBXXXA
    kNtcType_End,
}NtcType;

#define KIT_NTC_TEMP_OPEN_VALUE     1400     //
#define KIT_NTC_TEMP_SHORT_VALUE    0    //
#define BSP_NTC_TABLE_LEN           168     //NTC表格长度

#define NTC_TABLE_BUF_LEN             ((168 + 4) * 2)

NtcType bms_get_temp_table(NtcType tab, uint8_t *buf);
uint16_t bms_get_linear_temp(int32_t res, NtcType tab);



#ifdef __cplusplus
}
#endif

#endif
