/**
  ******************************************************************************
  * @file    BF8915A.c
  * @version V1.1.4
  * @date    2021-12-20
  * @brief   This file provides the BF8915A functions(ļṩBF8915A).
 */
#include "bsp_bf8915a.h"


Reg_TypeDef configAArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹA,ڴ洢ָ
uint8_t write_buffer[TOTAL_IC * 0x6U];//Ĵ68λĴ

Reg_TypeDef configBArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹB,ڴ洢ָ
Reg_TypeDef configCArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹC,ڴ洢ָ
Reg_TypeDef configDArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹC,ڴ洢ָ
///*!
//    \brief      SPI1_ReadWriteByte(SPI1дһֽ)
//    \param[in]  SPI_TxData     :SPIҪ͵
//    \retval     SPI_ReceiveData:SPIյ
//*/
//uint8_t SPI1_ReadWriteByte(uint8_t TxData) //TxData 8λ16λģSPI֮ǰȷ֡ʽ
//{       
//    u8 retry = 0;                         
//    while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET)//ǷָSPI־仺ձ־ //0:ͻǿ  ȴͻ
//    {
//			retry++;
//			if(retry>200)return 0;
//    }             
//    SPI_I2S_SendData(SPI1, TxData);//ͨSPI1ݡ
//    retry=0;
//    while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET)//ȴ,ָSPI־λ:ջǿձ־λ
//    {
//			retry++;
//			if(retry>200)return 0;
//    }                               
//    return SPI_I2S_ReceiveData(SPI1); //յݣSPI_DRĴ                      
//}

///*!
//    \brief      //SPI2дֽڣΪSTM32SPIΪοͻԼMCU޸
//    \param[in]  SPI_TxData     :SPI2Ҫ͵
//    \retval     SPI_ReceiveData:SPI2յ
//*/
//uint8_t SPI2_ReadWriteByte(uint8_t TxData)
//{		
//	u8 retry=0;				 	
//	while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET)//ָSPI־λ:ͻձ־λ
//		{
//		retry++;
//		if(retry>200)return 0;
//		}			  
//	SPI_I2S_SendData(SPI2, TxData);//ͨSPIxһ
//	retry=0;

//	while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET)//ָSPI־λ:ܻǿձ־λ
//		{
//		retry++;
//		if(retry>200)return 0;
//		}	  						    
//	return SPI_I2S_ReceiveData(SPI2);//ͨSPIxյ					    
//}

BOOLEAN	isospi_reverse = FALSE;//ıñʵ־ջSPIͨš
                                //FALSE:ԵͨţSDKеSPI1ΪͨţSPI1ջӵĵһICIC0;
                                //TURE: ԵķͨţSDKеSPI2ΪԷͨţҲSPI1ջӵĵһICIC0
const uint16_t crc15Table[256] = {0x0000, 0xc599, 0xceab, 0x0b32, 0xd8cf, 0x1d56, 0x1664, 0xd3fd, 0xf407, 0x319e, 0x3aac,	0xff35, 0x2cc8, 0xe951, 0xe263, 0x27fa,
                        	        0xad97, 0x680e, 0x633c, 0xa6a5, 0x7558, 0xb0c1,	0xbbf3, 0x7e6a, 0x5990, 0x9c09, 0x973b, 0x52a2, 0x815f, 0x44c6, 0x4ff4, 0x8a6d,
                                 	0x5b2e,	0x9eb7, 0x9585, 0x501c, 0x83e1, 0x4678, 0x4d4a, 0x88d3, 0xaf29, 0x6ab0, 0x6182, 0xa41b,	0x77e6, 0xb27f, 0xb94d, 0x7cd4,
                                 	0xf6b9, 0x3320, 0x3812, 0xfd8b, 0x2e76, 0xebef, 0xe0dd,	0x2544, 0x02be, 0xc727, 0xcc15, 0x098c, 0xda71, 0x1fe8, 0x14da, 0xd143, 
	                                0xf3c5, 0x365c,	0x3d6e, 0xf8f7, 0x2b0a, 0xee93, 0xe5a1, 0x2038, 0x07c2, 0xc25b, 0xc969, 0x0cf0, 0xdf0d,	0x1a94, 0x11a6, 0xd43f,
                                 	0x5e52, 0x9bcb, 0x90f9, 0x5560, 0x869d, 0x4304, 0x4836, 0x8daf,	0xaa55, 0x6fcc, 0x64fe, 0xa167, 0x729a, 0xb703, 0xbc31, 0x79a8,
                      	          0xa8eb, 0x6d72, 0x6640,	0xa3d9, 0x7024, 0xb5bd, 0xbe8f, 0x7b16, 0x5cec, 0x9975, 0x9247, 0x57de, 0x8423, 0x41ba, 0x4a88, 0x8f11,
                            	    0x057c, 0xc0e5, 0xcbd7, 0x0e4e, 0xddb3, 0x182a, 0x1318, 0xd681, 0xf17b,	0x34e2, 0x3fd0, 0xfa49, 0x29b4, 0xec2d, 0xe71f, 0x2286,
              	                  0xa213, 0x678a, 0x6cb8, 0xa921,	0x7adc, 0xbf45, 0xb477, 0x71ee, 0x5614, 0x938d, 0x98bf, 0x5d26, 0x8edb, 0x4b42, 0x4070, 0x85e9,
	                                0x0f84, 0xca1d, 0xc12f, 0x04b6, 0xd74b, 0x12d2, 0x19e0, 0xdc79, 0xfb83, 0x3e1a, 0x3528, 0xf0b1, 0x234c, 0xe6d5, 0xede7, 0x287e, 
	                                0xf93d, 0x3ca4, 0x3796, 0xf20f, 0x21f2, 0xe46b, 0xef59,	0x2ac0, 0x0d3a, 0xc8a3, 0xc391, 0x0608, 0xd5f5, 0x106c, 0x1b5e, 0xdec7,
	                                0x54aa, 0x9133, 0x9a01,	0x5f98, 0x8c65, 0x49fc, 0x42ce, 0x8757, 0xa0ad, 0x6534, 0x6e06, 0xab9f, 0x7862, 0xbdfb, 0xb6c9, 0x7350,
        	                        0x51d6, 0x944f, 0x9f7d, 0x5ae4, 0x8919, 0x4c80, 0x47b2, 0x822b, 0xa5d1, 0x6048, 0x6b7a,	0xaee3, 0x7d1e, 0xb887, 0xb3b5, 0x762c, 
	                                0xfc41, 0x39d8, 0x32ea, 0xf773, 0x248e, 0xe117, 0xea25,	0x2fbc, 0x0846, 0xcddf, 0xc6ed, 0x0374, 0xd089, 0x1510, 0x1e22, 0xdbbb, 
	                                0x0af8, 0xcf61, 0xc453,	0x01ca, 0xd237, 0x17ae, 0x1c9c, 0xd905, 0xfeff, 0x3b66, 0x3054, 0xf5cd, 0x2630, 0xe3a9, 0xe89b,	0x2d02, 
	                                0xa76f, 0x62f6, 0x69c4, 0xac5d, 0x7fa0, 0xba39, 0xb10b, 0x7492, 0x5368, 0x96f1, 0x9dc3,	0x585a, 0x8ba7, 0x4e3e, 0x450c, 0x8095
																 };//precomputed CRC15 Table(Ԥ15λѭУֵı)

/*!
    \brief      Wake isoSPI up from idle state(ջSPIӿ״̬)
    \param[in]  total_ic: number of ICs in the daisy chain(ջIC(8915A))
    \retval     none
*/
void wakeup_idle(uint8_t total_ic)
{
	int i =0;
  for (i =0; i<total_ic; i++)
  {
		if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
      cs_low();//ͨŵƬѡCSΪ͵ƽ
      SPI1_ReadWriteByte(0xff);//Guarantees the isoSPI will be in ready mode(֤ջSPIھģʽ)
      cs_high();//ͨŵƬѡCSΪߵƽ
    }
    else
    {
      cs_low_reverse();//ԷͨŵƬѡCSΪ͵ƽ
      SPI2_ReadWriteByte(0xff);//Guarantees the isoSPI will be in ready mode(֤ջSPIھģʽ)
      cs_high_reverse();//ԷͨŵƬѡCSΪߵƽ
    }
  }
}

/*!
    \brief      Generic wakeup command to wake the BF8915A from sleep(BF8915A˯лѵͨû)
    \param[in]  total_ic: the number of ic(ӵIC(8915A))
    \retval     none
*/
void wakeup_sleep(uint8_t total_ic)
{
	int i =0;
  for (i =0; i<total_ic; i++)//ѭΪ:IC(8915A)оƬڴ״̬
  {
		if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
      cs_low();//ͨŵƬѡCSΪ͵ƽ
	    delay_us(300); // Guarantees the BF8915A will be in standby(֤BF8915Aڴ״̬),ӳӦ200~300us֮
      cs_high();//ͨŵƬѡCSΪߵƽ
      delay_us(10);
    }
    else
    {
      cs_low_reverse();//ԷͨŵƬѡCSΪ͵ƽ
	    delay_us(300); // Guarantees the BF8915A will be in standby(֤BF8915Aڴ״̬),ӳӦ200~300us֮
      cs_high_reverse();//ԷͨŵƬѡCSΪߵƽ
      delay_us(10);
    }
  }
}

/*!
    \brief      Writes an array of bytes out of the SPI port(ֽдSPI˿)
    \param[in]  len      :Number of bytes to be written on the SPI port(SPI˿Ҫдֽ)
		\param[in]  writeData:Array of bytes to be written on the SPI port(ҪдSPI˿ڵֽ)
    \retval     none
*/
void spi_write_array(uint8_t len, uint8_t writeData[] )
{
	uint8_t i = 0;
  for (i = 0; i < len; i++)//ѭwriteData[] һһͳȥ
  {
		if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
	 
      SPI1_ReadWriteByte((int8_t)writeData[i]);
		
    }
    else
    {
      SPI2_ReadWriteByte((int8_t)writeData[i]);
    }
  }
}

/*!
    \brief      Writes and read a set number of bytes using the SPI port(ʹSPI˿дͶȡ趨ֽ)
		\param[in]  tx_Data: array of data to be written on SPI port(ҪдSPI˿ڵ)
    \param[in]  tx_len : length of the tx_data arr(tx_dataĳ)
    \param[in]  rx_data: Input: array that will store the data read by the SPI port(:洢SPI˿ڶȡݵ)
		\param[in]  rx_len : Option: number of bytes to be read from the SPI port(ѡ:SPI˿Ҫȡֽ)
    \retval     none
*/
void spi_write_read(uint8_t tx_Data[],//array of data to be written on SPI port
                    uint8_t tx_len, //length of the tx data arr
                    uint8_t *rx_data,//Input: array that will store the data read by the SPI port
                    uint8_t rx_len //Option: number of bytes to be read from the SPI port
                   )
{
	uint8_t i = 0;
  for (i = 0; i < tx_len; i++)//ѭtx_Data[] һһͳȥ
  {
		if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
      SPI1_ReadWriteByte(tx_Data[i]);
    }
    else
    {
      SPI2_ReadWriteByte(tx_Data[i]);
    }
  }

  for (i = 0; i < rx_len; i++)//ѭһһrx_data[] 
  {
		if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
      rx_data[i] = (uint8_t)SPI1_ReadWriteByte(0x00);
    }
    else
    {
      rx_data[i] = (uint8_t)SPI2_ReadWriteByte(0xFF);
    }
  }
}

/*!
    \brief      Generic function to write BF8915A commands. Function calculated PEC(The Packet Error Code) for tx_cmd data(дBF8915Aͨú??Ϊtx_cmdݼ˼)
		\param[in]  tx_cmd: 2 Byte array containing the BMS command to be sent(Ҫ͵BMS(عϵͳ)2ֽ)
    \retval     none
*/
void BF8915A_cmd(uint8_t tx_cmd[2])
{
	uint8_t cmd[4];//Ҫ͵4ֽ
	uint16_t cmd_pec;//ָPEC()
	cmd[0]  = tx_cmd[0];//ָĸ8λ
	cmd[1]  = tx_cmd[1];//ָĵ8λ
	cmd_pec = pec15_calc(2, cmd);//ָPEC()
	cmd[2]  = (uint8_t)(cmd_pec >> 8);//ָPEC()ĸ߰λ
	cmd[3]  = (uint8_t)(cmd_pec);//ָPEC()ĵͰλ

		if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
	    cs_low();//ƬѡCSΪ͵ƽ
	    spi_write_array(4,cmd);//4ֽдSPI˿
	    cs_high();//ƬѡCSΪߵƽ
    }
    else
    {
	    cs_low_reverse();//ƬѡCSΪ͵ƽ
	    spi_write_array(4,cmd);//4ֽдSPI˿
	    cs_high_reverse();//ƬѡCSΪߵƽ
    }
}

/*!
    \brief      Generic function to write BF8915A commands and write payload data. Function calculated PEC for tx_cmd data(дBF8915AдЧغݵͨútx_cmdݵĺ)
    \param[in]  total_ic  : the number of ic(IC(8915A))
    \param[in]  tx_cmd    : 2 Byte array containing the BMS command to be sent(Ҫ͵BMS(عϵͳ)2ֽ)
		\param[in]  write_data: Array containing the data to be written to the BMS ICs(ҪдBMS(عϵͳ)IC(8915A))
    \retval     none
*/
void BF8915A_write(uint8_t total_ic , 
									 uint8_t tx_cmd[2],
									 uint8_t write_data[] 
									 )
{
	const uint8_t BYTES_IN_REG = 6;//Ĵе68λĴ
	const uint8_t CMD_LEN = 4+(8*total_ic);//4:cmd[0]~cmd[3];(8*total_ic):Ĵе68λĴ + 28λPEC()
	uint8_t *cmd;//Ҫ͵cmd
	uint16_t data_pec;//üĴݵPEC()
	uint16_t cmd_pec;//ָPEC()
	uint8_t cmd_index;//дָ Ĵе
	uint8_t current_ic = total_ic;// current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
	uint8_t current_byte = 0;//ǰдļĴ ֽ
	cmd = (uint8_t *)malloc(CMD_LEN*sizeof(uint8_t));//cmd鷢鳤
	cmd[0]  = tx_cmd[0];//ָĸ8λ
	cmd[1]  = tx_cmd[1];//ָĵ8λ
	cmd_pec = pec15_calc(2, cmd);//ָPEC()
	cmd[2]  = (uint8_t)(cmd_pec >> 8);//ָPEC()ĸ߰λ
	cmd[3]  = (uint8_t)(cmd_pec);//ָPEC()ĵͰλ
	cmd_index = 4;//4ʼдĴе
	for (current_ic = total_ic; current_ic > 0; current_ic--)       // executes for each BF8915A, this loops starts with the last IC on the stack(ÿBF8915AִУѭӶջϵһ8915Aʼ)
  {	                                                              //The first configuration written is received by the last IC in the daisy chain(ջеһIC(8915A)дĵһ)

		for (current_byte = 0; current_byte < BYTES_IN_REG; current_byte++)//ѭĴе68λĴһһдcmd[]
		{
			cmd[cmd_index] = write_data[((current_ic-1)*BYTES_IN_REG)+current_byte];
			cmd_index = cmd_index + 1;
		}
		data_pec = (uint16_t)pec15_calc(BYTES_IN_REG, &write_data[(current_ic-1)*BYTES_IN_REG]);// calculating the PEC for each configuration register data(ÿüĴݵPEC())
		cmd[cmd_index] = (uint8_t)(data_pec >> 8);//üĴݵPEC()ĸ߰λ
		cmd[cmd_index + 1] = (uint8_t)data_pec;//üĴݵPEC()ĵͰλ
		cmd_index = cmd_index + 2;//ÿĴдÿICβ2ֽڵPEC()cmd_indexÿζ2
	}
		if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
	    cs_low();//ƬѡCSΪ͵ƽ
	    spi_write_array(CMD_LEN, cmd);//ֽдSPI˿
	    cs_high();//ƬѡCSΪߵƽ
    }
    else
    {
	    cs_low_reverse();//ƬѡCSΪ͵ƽ
	    spi_write_array(CMD_LEN, cmd);//ֽдSPI˿
	    cs_high_reverse();//ƬѡCSΪߵƽ
    }
	free(cmd);//cmd
}

/*!
    \brief      Generic function to write BF8915A commands and read data(дBF8915AͶݵͨú). Function calculated PEC for tx_cmd data(ָݵĺPEC())
                Issues a command onto the daisy chain and reads back 6*total_ic data in the rx_data array(ջضrx_dataе6IC(8915A))
    \param[in]  total_ic : the number of ic(IC(8915A))		
    \param[in]  tx_cmd   : 2 Byte array containing the BMS command to be sent(Ҫ͵BMS(عϵͳ)2ֽ)
		\param[in]  rx_data  : Array that the read back data will be stored(洢ضݵ)
    \retval     pec_error: 0: Data read back has matching PEC;1: Data read back has incorrect PEC(0:ݶؾƥļ 1:ݶвȷļ)
*/
uint8_t BF8915A_read(uint8_t total_ic , 
										 uint8_t tx_cmd[2], 
										 uint8_t *rx_data) 
{
	const uint8_t BYTES_IN_REG = 8;//Ĵе68λĴ + 28λPEC()
	uint8_t cmd[4];//Ҫ͵cmd
	uint8_t rxDataTemp[256];//洢SPI˿ڶȡ 
	uint8_t pec_error = 0;//
	uint16_t cmd_pec;//ָPEC()
	uint16_t data_pec;//üĴݵPEC()
	uint16_t received_pec;//յPEC()
	uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
	uint8_t current_byte = 0;//ǰļĴ
	cmd[0]  = tx_cmd[0];//ָĸ8λ
	cmd[1]  = tx_cmd[1];//ָĵ8λ
	cmd_pec = pec15_calc(2, cmd);//ָPEC()
	cmd[2]  = (uint8_t)(cmd_pec >> 8);//ָPEC()ĸ߰λ
	cmd[3]  = (uint8_t)(cmd_pec);//ָPEC()ĵͰλ

	
  if (isospi_reverse == FALSE)//жѡľջͨŷԷ
  {
	  cs_low();//ƬѡCSΪ͵ƽ
	  spi_write_read(cmd, 4, rxDataTemp, (total_ic*BYTES_IN_REG));//Read the configuration data of all ICs on the daisy chain into rx_data[] array
	  cs_high();//ƬѡCSΪߵƽ                           //(ջIC(8915A)ݶrx_data[])
  }
  else
  {
	  cs_low_reverse();//ƬѡCSΪ͵ƽ
	  spi_write_read(cmd, 4, rxDataTemp, (total_ic*BYTES_IN_REG));//Read the configuration data of all ICs on the daisy chain into rx_data[] array
	  cs_high_reverse();//ƬѡCSΪߵƽ                           //(ջIC(8915A)ݶrx_data[])
  }

	for (current_ic = 0; current_ic < total_ic; current_ic++) //executes for each BF8915A in the daisy chain and packs the data(ԾջеÿBF8915Aִв)
																	                          //into the r_comm array as well as check the received data for any bit errors(յǷκλ)
	{
		for (current_byte = 0; current_byte < BYTES_IN_REG; current_byte++)//ѭصļĴ(68λĴ)һһдrx_data[]
		{
			rx_data[(current_ic*BYTES_IN_REG)+current_byte] = rxDataTemp[(current_ic*BYTES_IN_REG)+current_byte];
		}
		received_pec = (rx_data[(current_ic*BYTES_IN_REG)+6]<<8) + rx_data[(current_ic*BYTES_IN_REG)+7];//rx_data[]нյPEC()ߵ͹16λreceived_pec
		
		data_pec = pec15_calc(6, &rx_data[current_ic*BYTES_IN_REG]);//ջļĴ(68λĴ)еPEC()
		if (received_pec != data_pec)//Ƿƥ
		{
		  pec_error = 1;//벻ȷ
		}
	}
	return(pec_error);
}

/*!
    \brief      Calculates and returns the CRC15(㲢15λѭУֵ)
		\param[in]  len    : Number of bytes that will be used to calculate a PEC(ڼPEC()ֽ)
		\param[in]  pecData: Array of data that will be used to calculate a PEC(ڼPEC())
    \retval     The calculated pec15 as an unsigned int(޷15λ)
*/
uint16_t pec15_calc(uint8_t len, 
                    uint8_t *pecData 
                   )
{
	uint16_t remainder,addr;
	uint8_t i = 0;
	remainder = 16;//initialize the PEC(ʼ)
	for (i = 0; i<len; i++) // loops for each byte in data array(ÿֽڵѭ)
	{
		addr = ((remainder>>7)^pecData[i])&0xff;//calculate PEC table address(ıַ)
		remainder = (remainder<<8)^crc15Table[addr];
	}
	return(remainder*2);//The CRC15 has a 0 in the LSB so the remainder must be multiplied by 2(15λѭУֵЧλΪ02)
}

/*!
    \brief      Helper function to set GPIO bits(GPIOλĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configAReg: Register group A(ĴA)
    \param[in]  gpio_pd_en: 0: GPIO pin pull-down enable; 1: GPIO pin pull-down disable (default)(0:GPIOʹܣ1:GPIO(Ĭ))
    \retval     none
*/
void BF8915A_set_cfga_gpio(uint8_t nIC, Reg_TypeDef *configAReg,uint8_t gpio_pd_en)
{
	configAReg[nIC].tx_data[0] = gpio_pd_en;//CFGAR0,0:GPIOʹܣ1:GPIO
}

/*!
    \brief      Helper function to set GPIO IO_MODE(GPIOIOģʽĸ)
		\param[in]  nIC           : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configAReg    : Register group A(ĴA)
		\param[in]  gpio_analog_en: 0: analog input;1: Ordinary GPIO(0:ģ룻1:ͨGPIO)
    \retval     none
*/
void BF8915A_set_cfga_gpio_mode(uint8_t nIC, Reg_TypeDef *configAReg,uint8_t gpio_analog_en)
{
	configAReg[nIC].tx_data[1] = gpio_analog_en;//CFGAR1,0:ģ룻1:ͨGPIO
}

void BF8915A_set_cfga_adc_init_mode(uint8_t nIC, Reg_TypeDef *configAReg,bool adc_init_mode)
{
	  if (adc_init_mode)
		configAReg[nIC].tx_data[2] = configAReg[nIC].tx_data[2]|(0x01<<4);
    else 
		configAReg[nIC].tx_data[2] = configAReg[nIC].tx_data[2]&(~(0x01 <<4));
}

/*!
    \brief      λԶ0
    \retval     none
*/
void BF8915A_set_cfga_rsvd(uint8_t nIC, Reg_TypeDef *configAReg,BOOLEAN rsvd2,BOOLEAN rsvd1)
{
		configAReg[nIC].tx_data[2] = configAReg[nIC].tx_data[2]&(~(0x01<<3));//λԶ0
		configAReg[nIC].tx_data[2] = configAReg[nIC].tx_data[2]&(~(0x01<<2));//λԶ0
} 

/*!
    \brief      Helper function to set osr_sel(ADCѡĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configAReg: Register group A(ĴA)
		\param[in]  osr_sel   : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ)
    \retval     none
*/ 
void BF8915A_set_cfga_osr_sel(uint8_t nIC, Reg_TypeDef *configAReg,BOOLEAN osr_sel)
{
		configAReg[nIC].tx_data[2] = configAReg[nIC].tx_data[2]&(~(0x01<<1));//д0,ѡ64128256512(ָֹͨOSRѡ)
}

/*!
    \brief      Helper function to set refon(û׼ѹõĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configAReg: Register group A(ĴA)
		\param[in]  refon     : 1: VREF1 remains powered on until WDT overflowsVREF1
						                0: VREF1 is turned off after ADC conversion
                          (1:VREF1(׼ѹ)ϵֱWDT  
                            0:ADCת֮VREF1ر (Ĭ))
    \retval     none
*/
void BF8915A_set_cfga_refon(uint8_t nIC, Reg_TypeDef *configAReg,BOOLEAN refon)
{
    if (refon)//CFGAR2ĵ1λ
		configAReg[nIC].tx_data[2] = configAReg[nIC].tx_data[2]|(0x01);//д1,VREF1(׼ѹ)ϵֱWDT 
    else 
		configAReg[nIC].tx_data[2] = configAReg[nIC].tx_data[2]&(~(0x01));//д0,ADCת֮VREF1ر
}

/*!
    \brief      Helper Function to set uv value in CFG register(üĴļĴǷѹֵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configAReg: Register group A(ĴA)
		\param[in]  uv        : Low 8 bits of undervoltage threshold(8λǷѹֵ)
    \retval     none
*/
void BF8915A_set_cfga_uv(uint8_t nIC, Reg_TypeDef *configAReg,uint16_t uv)
{
  configAReg[nIC].tx_data[3] = 0x00FF & uv;//CFGAR3,Ƿѹֵ8λ
  configAReg[nIC].tx_data[4] = configAReg[nIC].tx_data[4]&0xF0;//CFGAR44λ
  configAReg[nIC].tx_data[4] = configAReg[nIC].tx_data[4]|((0x0F00 & uv)>>8);//CFGAR44λǷѹֵ4λ
}

/*!
    \brief      helper function to set OV value in CFG register(üĴļĴùѹֵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configAReg: Register group A(ĴA)
		\param[in]  ov        : Overvoltage threshold lower 4 bits(ѹֵ4λ)
    \retval     none
*/
void BF8915A_set_cfga_ov(uint8_t nIC, Reg_TypeDef *configAReg,uint16_t ov)
{
  configAReg[nIC].tx_data[5] = 0x00FF & (ov>>4);//CFGAR5,ѹֵ8λ
  configAReg[nIC].tx_data[4] = configAReg[nIC].tx_data[4]&0x0F;//CFGAR44λ
  configAReg[nIC].tx_data[4] = configAReg[nIC].tx_data[4]|((0x000F & ov)<<4);//CFGAR44λѹֵ4λ
                                                                             //CFGAR44λǷѹֵ4λ
}
/*!
    \brief      Helper function to set CFGRA variable(üĴAĸ)
		\param[in]  nIC           : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configAReg    : Register group A(ĴA)
		\param[in]  gpio_pd_en    : GPIO pin pull-down enable; 1: GPIO pin pull-down disable (default)(0:GPIOʹܣ1:GPIO(Ĭ))
		\param[in]  gpio_analog_en: 0: analog input 1: Ordinary GPIO(0:ģ룻1:ͨGPIO)
		\param[in]  rsvd2         : λԶ0
		\param[in]  rsvd1         : λԶ0
		\param[in]  osr_sel       : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ)
		\param[in]  refon         : 1: VREF1 remains powered on until WDT overflowsVREF1
						                    0: VREF1 is turned off after ADC conversion
                              (1:VREF1(׼ѹ)ϵֱWDT  
                                0:ADCת֮VREF1ر (Ĭ))
		\param[in]  uv_th         : Low 8 bits of undervoltage threshold(8λǷѹֵ)
		\param[in]  ov_th         : Overvoltage threshold lower 4 bits(ѹֵ4λ)
    \retval     none
*/
void BF8915A_set_cfgra(uint8_t nIC, 
											 Reg_TypeDef *configAReg, 
											 uint8_t gpio_pd_en,//д0:GPIOʹܣ1:GPIOر(Ĭ)0 :GPIOŵֵ0 1:GPIOŵֵ1
											 uint8_t gpio_analog_en,//GPIO0~7ģʽѡ 0:ģ 1:ͨGPIO
                       BOOLEAN adc_inti_mode,
											 BOOLEAN rsvd2,//λԶ0
											 BOOLEAN rsvd1,//λԶ0
											 BOOLEAN osr_sel,//0:ѡ64128256512(ָֹͨOSRѡ)
																		   //ĴλҪָOSRһѡADC 
											 BOOLEAN refon,  //VREF1(׼ѹ)  1 :VREF1ϵֱWDT  0 :ADCת֮VREF1ر (Ĭ)
											 uint16_t uv_th,//Under voltage Comparison Voltage(Ƿѹֵ)ʵ趨  
		                                  //Under voltage threshold ADC Code(Ƿѹֵģת): uv_th = 3000 * 65535U / 5000U. LSB = 0.0001 ---(3V)
											 uint16_t ov_th //Over  voltage Comparison Voltage(ѹֵ)ʵ趨
                                      //Over  voltage threshold ADC Code(ѹֵģת): ov_th = 4100 * 65535U / 5000U. LSB = 0.0001 ---(4.1V)
											 )
{
	BF8915A_set_cfga_gpio(nIC, configAReg, gpio_pd_en);//CFGAR0
	BF8915A_set_cfga_gpio_mode(nIC, configAReg,gpio_analog_en);//CFGAR1
  BF8915A_set_cfga_adc_init_mode(nIC, configAReg,adc_inti_mode);
	BF8915A_set_cfga_rsvd(nIC, configAReg,rsvd2,rsvd1);//λԶ0
	BF8915A_set_cfga_osr_sel(nIC, configAReg,osr_sel);//CFGAR2ĵ2λ
	BF8915A_set_cfga_refon(nIC, configAReg,refon);//CFGAR2ĵ1λ
	BF8915A_set_cfga_uv(nIC, configAReg,uv_th);//CFGAR3CFGAR44λ
	BF8915A_set_cfga_ov(nIC, configAReg,ov_th);//CFGAR5CFGAR44λ
}

/*!
    \brief      Helper function to control discharge(Ʒŵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configBReg: Register group B(ĴB)
		\param[in]  dcc       :	1: Turn on  the switch of Cell x(xŵصĿ)
							              0: Turn off the switch of Cell x(رxŵصĿ)
    \retval     none
*/
void BF8915A_set_cfgb_dcc(uint8_t nIC, Reg_TypeDef *configBReg,uint16_t dcc)
{
	configBReg[nIC].tx_data[0] = (uint8_t)dcc;//CFGBR0,ŵؿx=1~8
	configBReg[nIC].tx_data[1] = (uint8_t)(dcc >> 0x8U);//CFGBR1,ŵؿx=9~16
}

/*!
    \brief      Balanced duty cycle selection(ռձѡ)
		\param[in]  nIC        : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configBReg : Register group B(ĴB)
		\param[in]  bl_duty_sel: Active balancing duty cycle selection(ռձѡ)
    \retval     none
*/
//bl_duty_sel(4λ): ռձѡ,ռձ=(BL_DUTY_SEL+1)*10%÷Χ10%~100%9ʱ100%
void BF8915A_set_cfgb_bl_duty_sel(uint8_t nIC, Reg_TypeDef *configBReg,
								uint8_t bl_duty_sel
								)
{
	configBReg[nIC].tx_data[2] = configBReg[nIC].tx_data[2] & 0x0F;//CFGBR2ĸ4λ
	configBReg[nIC].tx_data[2] = configBReg[nIC].tx_data[2] | ((0x0F & bl_duty_sel)<<4);//CFGBR24λ,ռձѡ
                                                                                      //CFGBR24λ
}

/*!
    \brief      Helper function to set dcto(÷ŵ綨ʱֵõĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configBReg: Register group B(ĴB)
		\param[in]  dcto      : Discharge timing overflow value configuration(ŵ綨ʱֵãϸ˵DCTOʾ)
    \retval     none
*/
void BF8915A_set_cfgb_dcto(uint8_t nIC, Reg_TypeDef *configBReg,
								uint8_t dcto
								)
{
	configBReg[nIC].tx_data[2] = configBReg[nIC].tx_data[2] & 0xF0;//CFGBR2ĵ4λ
	configBReg[nIC].tx_data[2] = configBReg[nIC].tx_data[2] | (0x0F & dcto);//CFGBR24λ,ŵ綨ʱֵ
                                                                          //CFGBR24λ
}

/*!
    \brief      Helper function to set vuv_bl(þǷѹֵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configBReg: Register group B(ĴB)
		\param[in]  vuv_bl    : Lower 8 bits of equalization undervoltage threshold(Ƿѹֵĵ8λ)
    \retval     none
*/
void BF8915A_set_cfgb_vuv_bl(uint8_t nIC, Reg_TypeDef *configBReg,
								             uint16_t vuv_bl//Ƿѹֵ(12λ)
								)
{
	configBReg[nIC].tx_data[3] = vuv_bl & 0xFF;//CFGBR3,Ƿѹֵ8λ
	configBReg[nIC].tx_data[4] = configBReg[nIC].tx_data[4] & 0xF0;//CFGBR4ĵ4λ
	configBReg[nIC].tx_data[4] = configBReg[nIC].tx_data[4] | ((vuv_bl & 0x0F00U) >> 0x8U);//CFGBR44λ,Ƿѹֵ4λ
                                                                                         //CFGBR44λ
}

/*!
    \brief      Helper function to set bl_dtmen(÷ŵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configBReg: Register group B(ĴB)
		\param[in]  dtmen     : Enable discharge monitor(÷ŵ) 1: Enable  discharge monitor(÷ŵ)
														                                         0: Disable discharge monitor(÷ŵ)
    \retval     none
*/
void BF8915A_set_cfgb_bl_dtmen(uint8_t nIC, Reg_TypeDef *configBReg,
								BOOLEAN dtmen
								)
{
	  if (dtmen)//CFGAR4ĵ5λ
		configBReg[nIC].tx_data[4] = configBReg[nIC].tx_data[4] | (0x01<<4);//д1,ʹܷŵ
    else 
		configBReg[nIC].tx_data[4] = configBReg[nIC].tx_data[4] & (~(0x01<<4));//д0,ʹܷŵ
}

/*!
    \brief      Helper function to set CFGRB variable(üĴBĸ)
		\param[in]  nIC        : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configBReg : Register group B(ĴB)
		\param[in]  dcc        :	1: Turn on  the switch of Cell x(xصĿ)
							                0: Turn off the switch of Cell x(رxصĿ)
		\param[in]  bl_duty_sel: Active balancing duty cycle selection(ռձѡ)
		\param[in]  dcto       : Discharge timing overflow value configuration(ŵ綨ʱֵ)
		\param[in]  vuv_bl     : Lower 8 bits of equalization undervoltage threshold(Ƿѹֵĵ8λ)
		\param[in]  dtmen      : Enable discharge monitor(ʹܷŵ)	1: Enable  discharge monitor(÷ŵ)
														                                            0: Disable discharge monitor(÷ŵ)
    \retval     none
*/
void BF8915A_set_cfgrb(uint8_t nIC, 
											 Reg_TypeDef *configBReg,
											 uint16_t dcc,//ŵؿ1:Cell x Ŀ  0:رCell x Ŀ (Ĭ)
											 uint8_t bl_duty_sel,//ռձѡ ռձ=(BL_DUTY_SEL+1)*10%÷Χ10%~100%9ʱ100%
											 uint8_t dcto,//ŵ綨ʱֵ
											 uint16_t vuv_bl,//Ƿѹֵ
											 BOOLEAN dtmen//Զ£DTMEN=1Ƿѹ(СVUV_BL)رշŵ翪أDTMEN=0ǷѹȽ
											 )
{
	BF8915A_set_cfgb_dcc(nIC, configBReg,dcc);//Ʒŵĸ
	BF8915A_set_cfgb_bl_duty_sel(nIC, configBReg,bl_duty_sel);//ռձѡ
	BF8915A_set_cfgb_dcto(nIC, configBReg,dcto);//÷ŵ綨ʱֵõĸ
	BF8915A_set_cfgb_vuv_bl(nIC, configBReg,vuv_bl);//þǷѹֵĸ
	BF8915A_set_cfgb_bl_dtmen(nIC, configBReg,dtmen);//÷ŵĸ
}

/*!
    \brief      Helper function to set Undervoltage threshold in monitoring mode(ģʽ£Ƿѹֵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configCReg: Register group C(ĴC)
		\param[in]  vuv_m     : Undervoltage threshold in monitoring mode(ģʽµǷѹֵ)
    \retval     none
*/
void BF8915A_set_cfgc_vuv_m(uint8_t nIC, Reg_TypeDef *configCReg,uint16_t vuv_m)
{
  configCReg[nIC].tx_data[0] = 0x00FF & vuv_m;//CFGCR0,ģʽ£Ƿѹֵ8λ
  configCReg[nIC].tx_data[1] = configCReg[nIC].tx_data[1]&0xF0;//CFGCR1ĵ4λ
  configCReg[nIC].tx_data[1] = configCReg[nIC].tx_data[1]|((0x0F00 & vuv_m)>>8);//CFGCR14λ,ģʽ£Ƿѹֵ4λ
                                                                                //CFGCR14λ
}

/*!
    \brief      Helper function to set Overvoltage  threshold in monitoring mode(ģʽ£ùѹֵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configCReg: Register group C(ĴC)
		\param[in]  vov_m     : Overvoltage threshold in monitoring mode(ģʽµĹѹֵ)
    \retval     none
*/
void BF8915A_set_cfgc_vov_m(uint8_t nIC, Reg_TypeDef *configCReg,uint16_t vov_m)
{
  configCReg[nIC].tx_data[2] = 0x00FF & (vov_m>>4);//CFGCR2,ģʽ£ѹֵ8λ
  configCReg[nIC].tx_data[1] = configCReg[nIC].tx_data[1]&0x0F;//CFGCR1ĸ4λ
  configCReg[nIC].tx_data[1] = configCReg[nIC].tx_data[1]|((0x000F & vov_m)<<4);//CFGCR14λ,ģʽ£ѹֵ4λ
                                                                                //CFGCR14λ
}

/*!
    \brief      Helper function to set Internal over-temperature threshold in monitoring mode(ģʽ£ڲֵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configCReg: Register group C(ĴC)
		\param[in]  itov_m    : In monitoring mode, internal over-temperature threshold(ģʽ£ڲֵ)
    \retval     none
*/
void BF8915A_set_cfgc_itov_m(uint8_t nIC, Reg_TypeDef *configCReg,uint16_t itov_m)
{
  configCReg[nIC].tx_data[3] = 0x00FF & itov_m;//CFGCR3,ģʽ£ڲֵ8λ
  configCReg[nIC].tx_data[4] = configCReg[nIC].tx_data[4]&0xF0;//CFGCR4ĵ4λ
  configCReg[nIC].tx_data[4] = configCReg[nIC].tx_data[4]|((0x0F00 & itov_m)>>8);//CFGCR44λ,ģʽ£ڲֵ4λ
                                                                                 //CFGCR44λ
}

/*!
    \brief      Helper function to set external over-temperature threshold in monitoring mode(ģʽ£ⲿֵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configCReg: Register group C(ĴC)
		\param[in]  extov_m   : In monitoring mode, external over-temperature threshold(ģʽ£ⲿֵ)
    \retval     none
*/
void BF8915A_set_cfgc_extov_m(uint8_t nIC, Reg_TypeDef *configCReg,uint16_t extov_m)
{
  configCReg[nIC].tx_data[5] = 0x00FF & (extov_m>>4);//CFGCR5,ģʽ£ⲿֵ8λ
  configCReg[nIC].tx_data[4] = configCReg[nIC].tx_data[4]&0x0F;//CFGCR4ĸ4λ
  configCReg[nIC].tx_data[4] = configCReg[nIC].tx_data[4]|((0x000F & extov_m)<<4);//CFGCR44λ,ģʽ£ⲿֵ4λ
                                                                                  //CFGCR44λ
}

/*!
    \brief      Helper function to set CFGRC variable(üĴCĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configCReg: Register group C(ĴC)
		\param[in]  vuv_m     : Undervoltage threshold in monitoring mode(ģʽµǷѹֵ)
		\param[in]  vov_m     : Overvoltage  threshold in monitoring mode(ģʽµĹѹֵ)
		\param[in]  itov_m    : Internal over-temperature threshold in monitoring mode(ģʽ£ڲֵ)
		\param[in]  extov_m   : external over-temperature threshold in monitoring mode(ģʽ£ⲿֵ)
    \retval     none
*/
void BF8915A_set_cfgrc(uint8_t nIC, 
					 Reg_TypeDef *configCReg, 
					 uint16_t vuv_m,//ģʽµǷѹֵ
					 uint16_t vov_m,//ģʽµĹѹֵ
					 uint16_t itov_m,//ģʽµڲֵ
					 uint16_t extov_m//ģʽµⲿֵ
					 )
{
	BF8915A_set_cfgc_vuv_m(nIC, configCReg,vuv_m);//ģʽ£Ƿѹֵĸ
	BF8915A_set_cfgc_vov_m(nIC, configCReg,vov_m);//ģʽ£ùѹֵĸ
	BF8915A_set_cfgc_itov_m(nIC, configCReg,itov_m);//ģʽ£ڲֵĸ
	BF8915A_set_cfgc_extov_m(nIC, configCReg,extov_m);//ģʽ£ⲿֵĸ
}

/*!
    \brief      Helper function to set csel_m(üģʽ£صѹȽѡĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg: Register group D(ĴD)
		\param[in]  csel_m    : In monitoring mode, battery voltage monitoring comparison selection cell1~cell16(ڼģʽ£صѹȽѡ1 ~16)
    \retval     none
*/
void BF8915A_set_cfgd_csel_m(uint8_t nIC, Reg_TypeDef *configDReg,uint16_t csel_m)
{
  configDReg[nIC].tx_data[0] = 0x00FF & csel_m;//CFGDR0صѹȽѡcell1~cell8
  configDReg[nIC].tx_data[1] = (csel_m & 0xFF00) >> 0x8U;//CFGDR1صѹȽѡcell9~cell16
}

/*!
    \brief      Helper function to set gsel_m(üģʽ£GPIO0~7Ƚѡĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg: Register group D(ĴD)
		\param[in]  gsel_m    : In monitoring mode, GPIO0~7 is compared and selected(ģʽ£GPIO0~7Ƚѡ)
    \retval     none
*/
void BF8915A_set_cfgd_gsel_m(uint8_t nIC, Reg_TypeDef *configDReg,uint8_t gsel_m)
{
  configDReg[nIC].tx_data[2] = gsel_m;//CFGDR2
}

/*!
    \brief      Helper function to set isospi_wake_t(þջʱĸ)
		\param[in]  nIC          : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg   : Register group D(ĴD)
		\param[in]  isospi_wake_t: isospi wake-up time, 0: 10us; 1:20us(isospi(ջSPI)ʱ䣬0:10us1:20us)
    \retval     none
*/
void BF8915A_set_cfgd_isospi_wake_t(uint8_t nIC, Reg_TypeDef *configDReg,BOOLEAN isospi_wake_t)
{
  if (isospi_wake_t)//CFGDR3ĵ8λ
		configDReg[nIC].tx_data[3] = configDReg[nIC].tx_data[3] | (0x01<<7);//д1
   else 
		configDReg[nIC].tx_data[3] = configDReg[nIC].tx_data[3] & (~(0x01<<7));//д0
}

/*!
    \brief      Helper function to set adc_rst_sel(ò1ͨADCλѡĸ)
		\param[in]  nIC        : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg : Register group D(ĴD)
		\param[in]  adc_rst_sel: 0: All measurement channels reset ADC(вͨλADC)
								             1: Only the first channel resets ADC, then 2~n channels do not reset ADC(ֻе1ͨλADC֮2~nͨλADC)
    \retval     none
*/
void BF8915A_set_cfgd_adc_rst_sel(uint8_t nIC, Reg_TypeDef *configDReg,BOOLEAN adc_rst_sel)
{
  if (adc_rst_sel)//CFGDR3ĵ7λ
		configDReg[nIC].tx_data[3] = configDReg[nIC].tx_data[3] | (0x01<<6);//д1
  else 
		configDReg[nIC].tx_data[3] = configDReg[nIC].tx_data[3] & (~(0x01<<6));//д0
}

/*!
    \brief      Helper function to set time_sel_m(üģʽ£ʱʱõĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg: Register group D(ĴD)
		\param[in]  time_sel_m: In monitoring mode, timing monitoring time configuration(ģʽ£ʱʱ)
    \retval     none
*/
//time_sel_m(5λ):ģʽ£ʱʱãʱʱ=(TIME_SEL_M+1)*1s(2~64s)Сֵ1(2s)
//ʱú;ù
void BF8915A_set_cfgd_time_sel_m(uint8_t nIC, Reg_TypeDef *configDReg,uint8_t time_sel_m)
{
  
	configDReg[nIC].tx_data[3] = configDReg[nIC].tx_data[3] & 0xC0U;//CFGDR36λ
	configDReg[nIC].tx_data[3] = configDReg[nIC].tx_data[3] | (time_sel_m & 0x3F);//CFGDR36λ
                                                                                //CFGDR32λ
}

/*!
    \brief      Helper function to set adc_init_t2(ADC2~nͨADCʼʱĸ)
		\param[in]  nIC        : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg : Register group D(ĴD)
		\param[in]  adc_init_t2: ADC measurement 2~n channel ADC initialization time(ADC2~nͨADCʼʱ)
    \retval     none
*/
//ADC2~nͨADCʼʱ䣬(ADC_INIT_T2+1)*20us(20~320us)
void BF8915A_set_cfgd_adc_init_t2(uint8_t nIC, Reg_TypeDef *configDReg,uint8_t adc_init_t2)
{
  
	configDReg[nIC].tx_data[4] = configDReg[nIC].tx_data[4] & 0x0FU;//CFGDR44λ
	configDReg[nIC].tx_data[4] = configDReg[nIC].tx_data[4] | ((adc_init_t2 & 0x0F) << 0x4U);//CFGDR44λ
                                                                                           //CFGDR44λ
}

/*!
    \brief      Helper function to set adc_init_t1(ADC1ͨADCʼʱĸ)
		\param[in]  nIC        : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg : Register group D(ĴD)
		\param[in]  adc_init_t1: ADC measurement 1 channel ADC initialization time(ADC1ͨADCʼʱ)
    \retval     none
*/
//ADC1ͨADCʼʱ(ADC_INIT_T1+1)*100us(100~1600us)
void BF8915A_set_cfgd_adc_init_t1(uint8_t nIC, Reg_TypeDef *configDReg,uint8_t adc_init_t1)
{
  
	configDReg[nIC].tx_data[4] = configDReg[nIC].tx_data[4] & 0xF0U;//CFGDR44λ
	configDReg[nIC].tx_data[4] = configDReg[nIC].tx_data[4] | (adc_init_t1 & 0x0F);//CFGDR44λ
                                                                                 //CFGDR44λ
}

/*!
    \brief      Helper function to set trim2_en(޵2ʹܵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg: Register group D(ĴD)
		\param[in]  trim2_en  : Modification 2 enable, 1: enable, 0: disable(޵2ʹܣ1:ʹܣ0:ʹ)
    \retval     none
*/
void BF8915A_set_cfgd_trim2_en(uint8_t nIC, Reg_TypeDef *configDReg,BOOLEAN trim2_en)
{
  if (trim2_en)//CFGDR5ĵ8λ
		configDReg[nIC].tx_data[5] = configDReg[nIC].tx_data[5] | (0x01<<7);//д1
   else 
		configDReg[nIC].tx_data[5] = configDReg[nIC].tx_data[5] & (~(0x01<<7));//д0
}

/*!
    \brief      Helper function to set trim1_en(޵1ʹܵĸ)
		\param[in]  nIC       : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg: Register group D(ĴD)
		\param[in]  trim1_en  : Modification 1 enable, 1: enable, 0: disable(޵1ʹܣ1:ʹܣ0:ʹ)
    \retval     none
*/
void BF8915A_set_cfgd_trim1_en(uint8_t nIC, Reg_TypeDef *configDReg,BOOLEAN trim1_en)
{
  if (trim1_en)//CFGDR5ĵ7λ
		configDReg[nIC].tx_data[5] = configDReg[nIC].tx_data[5] | (0x01<<6);//д1
   else 
		configDReg[nIC].tx_data[5] = configDReg[nIC].tx_data[5] & (~(0x01<<6));//д0
}

/*!
    \brief      Helper function to set trim1_en(üģʽ·쳣ϱļʱĸ)
		\param[in]  nIC        : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg : Register group D(ĴD)
		\param[in]  err_t_sel_m: When an exception occurs in the monitoring mode, the reporting interval(ģʽ·쳣ϱļʱ)
    \retval     none
*/
//err_t_sel_m(2λ):ģʽ·쳣ϱļʱ 00:200ms01:400ms10:600ms11:800ms
void BF8915A_set_cfgd_err_t_sel_m(uint8_t nIC, Reg_TypeDef *configDReg,uint8_t err_t_sel_m)
{
  
	configDReg[nIC].tx_data[5] = configDReg[nIC].tx_data[5] & 0xCFU;//CFGDR5ĵ6~5λ
	configDReg[nIC].tx_data[5] = configDReg[nIC].tx_data[5] | ((err_t_sel_m & 0x03) << 0x4U);//CFGDR56~5λ
                                                                                           //CFGDR58~7λ
}

/*!
    \brief      Helper function to set CFGRD variable(üĴDĸ)
		\param[in]  nIC 	    : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg: A two dimensional array of the configuration data that will be written(ҪдݵĶά)
		\param[in]  vd33t_on_m: A two dimensional array of the configuration data that will be written(ҪдݵĶά)
    \retval     none   	                  					  
*/
//vd33t_on_m:ģʽ£VREF1(׼ѹ)VD33Tʱ(5+VD33T_ON_M*10)msΧ5~155ms
void BF8915A_set_cfgd_vd33t_on_m(uint8_t nIC, Reg_TypeDef *configDReg,uint8_t vd33t_on_m)
{
	configDReg[nIC].tx_data[5] = configDReg[nIC].tx_data[5] & 0xF0U;//CFGDR5ĵ4λ
	configDReg[nIC].tx_data[5] = configDReg[nIC].tx_data[5] | (vd33t_on_m & 0x0F);//CFGDR54λCFGDR54λ
}

/*!
    \brief      Helper function to set CFGRD variable(üĴDĸ)
		\param[in]  nIC          : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDReg   : Register group D(ĴD)
		\param[in]  csel_m       : In monitoring mode, battery voltage monitoring comparison selection cell1~cell16(ڼģʽ£صѹȽѡ1~16)
		\param[in]  gsel_m       : In monitoring mode, GPIO0~7 comparison selection(ģʽ£GPIO0~7Ƚѡ)
		\param[in]  isospi_wake_t: isospi wake up time(ջʱ)
		\param[in]  adc_rst_sel  : 0: All measurement channels reset ADC(вͨλADC)
								                1: Only the first channel resets ADC, then 2~n channels do not reset ADC(ֻе1ͨλADC֮2~nͨλADC)
		\param[in]  time_sel_m   : In monitoring mode, timing monitoring time configuration, timing time=(TIME_SEL_M+1)*1s(2~64s), the minimum configuration value is 1(2s);This time configuration is shared with the balance period configuration
                              (ģʽ£ʱʱãʱʱ=(TIME_SEL_M+1)*1s(2~64s)Сֵ1(2s)ʱʱڵù)
		\param[in]  adc_init_t2  : ADC measures the ADC initialization time of the second to n channels, (ADC_INIT_T2+1)*20us (20~320us)(ADC2~nͨADCʼʱ䣬(ADC_INIT_T2+1)*20us(20~320us))
		\param[in]  adc_init_t1  : ADC measurement of the first channel ADC initialization time (ADC_INIT_T1+1)*100us (100~1600us)(ADC1ͨADCʼʱ(ADC_INIT_T1+1)*100us(100~1600us))
		\param[in]  trim2_en:1   : enable, 0: disable(޵2ʹܣ1:ʹܣ0:ʹ)
		\param[in]  trim1_en:1   : enable, 0: disable(޵1ʹܣ1:ʹܣ0:ʹ)
		\param[in]  err_t_sel_m  : 00: 200ms, 01: 400ms, 10: 600ms, 11: 800ms(ģʽ·쳣ϱļʱ  00:200ms01:400ms10:600ms11:800ms)
		\param[in]  vd33t_on_m   : The startup time configuration of VREF1 and VD33T (5+VD33T_ON_M*10)ms, the range is 5~155ms(ģʽ£VREF1VD33Tʱ(5+VD33T_ON_M*10)msΧ5~155ms)
    \retval     none   	                  					  
*/
void BF8915A_set_cfgrd(uint8_t nIC, 
					 Reg_TypeDef *configDReg, 
					 uint16_t csel_m,//ģʽ£صѹȽѡcell1~cell16
                           //1:Ӧĵؾͻڼģʽ½йǷѹȽϣñ־λ
                           //0:Ӧĵؾͻڼģʽ²йǷѹȽϣñ־λ
					 uint8_t gsel_m ,//ģʽ£GPIO0~7Ƚѡ
                           //1:Ӧĵؾͻڼģʽ½й(Сⲿ¶ֵ)Ƚϣñ־λ
                           //0:Ӧĵؾͻڼģʽ²й(Сⲿ¶ֵ)Ƚϣñ־λ
           BOOLEAN isospi_wake_t,//ջʱ䣬0: 10us1: 20us
					 BOOLEAN adc_rst_sel,//1ͨADCλѡ0:вͨλADC1:ֻе1ͨλADC֮2~nͨλADC
					 uint8_t time_sel_m,//ģʽ£ʱʱãʱʱ=(TIME_SEL_M+1)*1s(2~64s)Сֵ1(2s)
                              //ʱú;ù
					 uint8_t adc_init_t2,//ADC2~nͨADCʼʱ䣬(ADC_INIT_T2+1)*20us(20~320us)
					 uint8_t adc_init_t1,//ADC1ͨADCʼʱ(ADC_INIT_T1+1)*100us(100~1600us)
					 BOOLEAN trim2_en,//޵2ʹܣ1:ʹܣ0:ʹ
					 BOOLEAN trim1_en,//޵1ʹܣ1:ʹܣ0:ʹ
					 uint8_t err_t_sel_m,//ģʽ·쳣ϱļʱ
                               //00:200ms01:400ms10:600ms11:800ms
					 uint8_t vd33t_on_m//ģʽ£VREF1VD33Tʱ(5+VD33T_ON_M*10)msΧ5~155ms
					 )
{
	BF8915A_set_cfgd_csel_m(nIC, configDReg,csel_m);//üģʽ£صѹȽѡĸ
	BF8915A_set_cfgd_gsel_m(nIC, configDReg,gsel_m);//üģʽ£GPIO0~7Ƚѡĸ
	BF8915A_set_cfgd_isospi_wake_t(nIC, configDReg,isospi_wake_t);//þջʱĸ
	BF8915A_set_cfgd_adc_rst_sel(nIC, configDReg,adc_rst_sel);//ò1ͨADCλѡĸ
	BF8915A_set_cfgd_time_sel_m(nIC, configDReg,time_sel_m);//üģʽ£ʱʱõĸ
	BF8915A_set_cfgd_adc_init_t2(nIC, configDReg,adc_init_t2);//ADC2~nͨADCʼʱĸ
	BF8915A_set_cfgd_adc_init_t1(nIC, configDReg,adc_init_t1);//ADC1ͨADCʼʱĸ
	BF8915A_set_cfgd_trim2_en(nIC, configDReg,trim2_en);//޵2ʹܵĸ
	BF8915A_set_cfgd_trim1_en(nIC, configDReg,trim1_en);//޵1ʹܵĸ
	BF8915A_set_cfgd_err_t_sel_m(nIC, configDReg,err_t_sel_m);//üģʽ·쳣ϱļʱĸ
	BF8915A_set_cfgd_vd33t_on_m(nIC, configDReg,vd33t_on_m);//üĴDĸ
}

/*!
    \brief      Write the BF8915A CFGRA(дBF8915AüĴA)
		\param[in]  total_ic 	 : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configAData: A two dimensional array of the configuration data that will be written(ҪдݵĶά)
    \retval     none   	                  					  
*/

void BF8915A_wrcfga(uint8_t total_ic, ConfigA_TypeDef configAData[])
{
  uint8_t cmd[2] = {0x00 , 0x01};//дBF8915AüĴAָĸߵ͹16λ

  uint8_t write_count = 0;//ΪTOTAL_IC * 0x6U
  uint8_t c_ic = 0;//ǰд8915AоƬ
  uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  uint8_t dataTemp = 0;//ÿ6һѭڼÿĴ鵱ǰѭļĴ
	
	for (current_ic = 0; current_ic<total_ic; current_ic++)//ÿ8915AüĴA
	{
		BF8915A_set_cfgra(current_ic, 
											configAArray, 
											configAData[current_ic].gpio_pd_en,//д0:GPIOʹܣ1:GPIOر(Ĭ)0 :GPIOŵֵ0 1:GPIOŵֵ1
											configAData[current_ic].gpio_analog_en,//GPIO0~7ģʽѡ 0:ģ 1:ͨGPIO
                      configAData[current_ic].adc_init_mode,
											configAData[current_ic].rsvd2,//λԶ0
											configAData[current_ic].rsvd1,//λԶ0
											configAData[current_ic].osr_sel,//0:ѡ64128256512(ָֹͨOSRѡ)
																		                  //ĴλҪָOSRһѡADC 
											configAData[current_ic].refon,//VREF1(׼ѹ)  1 :VREF1ϵֱWDT  0 :ADCת֮VREF1ر (Ĭ)
											configAData[current_ic].uv_th,//Under voltage Comparison Voltage(Ƿѹֵ)ʵ趨  
		                                                //Under voltage threshold ADC Code(Ƿѹֵģת): uv_th = 3000 * 65535U / 5000U. LSB = 0.0001 ---(3V)
											configAData[current_ic].ov_th //Over  voltage Comparison Voltage(ѹֵ)ʵ趨
                                                    //Over  voltage threshold ADC Code(ѹֵģת): ov_th = 4100 * 65535U / 5000U. LSB = 0.0001 ---(4.1V)
											);
	}
	
  for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴAָ
  {
    if (isospi_reverse == TRUE)//жѡľջͨŷԷ
    {
      c_ic = current_ic;//ѡüĴAָ
    }
    else
    {
      c_ic = total_ic - current_ic - 1;//ѡüĴAָ
    }

    for (dataTemp = 0; dataTemp<6; dataTemp++)//isospiһֱΪFALSEѭüĴAúõһһд뷢Уͨ͸ÿ8915AоƬ
    {
      write_buffer[write_count] = configAArray[c_ic].tx_data[dataTemp];
      write_count++;
    }
  }
  BF8915A_write(total_ic, cmd, write_buffer);//дBF8915AдЧغݵͨú
}

/*!
    \brief      Write the BF8915A CFGRB(дBF8915AüĴB)
		\param[in]  total_ic 	 : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configBData: A two dimensional array of the configuration data that will be written(ҪдݵĶά)
    \retval     none   	                  					  
*/
void BF8915A_wrcfgb(uint8_t total_ic, 
                  ConfigB_TypeDef configBData[]
                  )
{
  uint8_t cmd[2] = {0x00 , 0x02};//дBF8915AüĴBָĸߵ͹16λ

  //uint8_t write_buffer[TOTAL_IC * 0x6U];//Ĵе68λĴ
  uint8_t write_count = 0;//ΪTOTAL_IC * 0x6U
  uint8_t c_ic = 0;//ǰд8915AоƬ
  uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  uint8_t dataTemp = 0;//ÿ6һѭڼÿĴ鵱ǰѭļĴ
	
	for (current_ic = 0; current_ic<total_ic; current_ic++)//ÿ8915AüĴB
	{
		BF8915A_set_cfgrb(current_ic, 
											configBArray, 
											configBData[current_ic].dcc,//ŵؿ1:Cell x Ŀ  0:رCell x Ŀ (Ĭ) 
											configBData[current_ic].bl_duty_sel,//ռձѡ  ռձ=(BL_DUTY_SEL+1)*10%÷Χ10%~100%9ʱ100%
											configBData[current_ic].dcto,//ŵ綨ʱֵ
											configBData[current_ic].vuv_bl_th,//Ƿѹֵ
											configBData[current_ic].dtmen//Զ£DTMEN=1Ƿѹ(СVUV_BL)رշŵ翪أDTMEN=0ǷѹȽ
											);
	}	
  for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴBָ
  {
    if (isospi_reverse == TRUE)//жѡľջͨŷԷ
    {
      c_ic = current_ic;//ѡüĴBָ
    }
    else
    {
      c_ic = total_ic - current_ic - 1;//ѡüĴBָ
    }

    for (dataTemp = 0; dataTemp<6; dataTemp++)//isospiһֱΪFALSEѭüĴBúõһһд뷢Уͨ͸ÿ8915AоƬ
    {
      write_buffer[write_count] = configBArray[c_ic].tx_data[dataTemp];
      write_count++;
    }
  }
  BF8915A_write(total_ic, cmd, write_buffer);//дBF8915AдЧغݵͨú
}

/*!
    \brief      Write the BF8915A CFGRC(дBF8915AüĴC)
		\param[in]  total_ic 	 : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configCData: A two dimensional array of the configuration data that will be written(ҪдݵĶά)
    \retval     none   	                  					  
*/
void BF8915A_wrcfgc(uint8_t total_ic,
										ConfigC_TypeDef configCData[]
										)
{
  uint8_t cmd[2] = {0x00 , 0x03};//дBF8915AüĴCָĸߵ͹16λ
//	Reg_TypeDef configCArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹC,ڴ洢ָ
  //uint8_t write_buffer[TOTAL_IC * 0x6U];//Ĵе68λĴ
  uint8_t write_count = 0;//ΪTOTAL_IC * 0x6U
  uint8_t c_ic = 0;//ǰд8915AоƬ
  uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  uint8_t data = 0;//ÿ6һѭڼÿĴ鵱ǰѭļĴ
	for (current_ic = 0; current_ic<total_ic; current_ic++)//ÿ8915AüĴC
	{
		BF8915A_set_cfgrc(current_ic, 
											configCArray, 
											configCData[current_ic].vuv_m_th,//ģʽ£Ƿѹֵ
											configCData[current_ic].vov_m_th,//ģʽ£ѹֵ
											configCData[current_ic].itov_m_th,//ģʽ£ڲֵ
											configCData[current_ic].extov_m_th//ģʽ£ⲿֵ
											);
	}
  for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴCָ
  {
    if (isospi_reverse == TRUE)//жѡľջͨŷԷ
    {
      c_ic = current_ic;//ѡüĴCָ
    }
    else
    {
      c_ic = total_ic - current_ic - 1;//ѡüĴCָ
    }

    for (data = 0; data<6; data++)//isospiһֱΪFALSEѭüĴCúõһһд뷢Уͨ͸ÿ8915AоƬ
    {
      write_buffer[write_count] = configCArray[c_ic].tx_data[data];
      write_count++;
    }
  }
  BF8915A_write(total_ic, cmd, write_buffer);//дBF8915AдЧغݵͨú
}

/*!
    \brief      Write the BF8915A CFGRD(дBF8915AüĴD)
		\param[in]  total_ic 	 : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDData: A two dimensional array of the configuration data that will be written(ҪдݵĶά)
    \retval     none   	                  					  
*/
void BF8915A_wrcfgd(uint8_t total_ic,
										ConfigD_TypeDef configDData[]
										)
{
  uint8_t cmd[2] = {0x00 , 0x04};//дBF8915AüĴDָĸߵ͹16λ
	//Reg_TypeDef configDArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹD,ڴ洢ָ
  //uint8_t write_buffer[TOTAL_IC * 0x6U];//Ĵе68λĴ
  uint8_t write_count = 0;//ΪTOTAL_IC * 0x6U
  uint8_t c_ic = 0;//ǰд8915AоƬ
  uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  uint8_t data = 0;//ÿ6һѭڼÿĴ鵱ǰѭļĴ
	
	for (current_ic = 0; current_ic<total_ic; current_ic++)//ÿ8915AüĴD
	{
		BF8915A_set_cfgrd(current_ic, 
											configDArray, 
											configDData[current_ic].csel_m, //ģʽ£صѹȽѡ 1:Ӧĵؾͻڼģʽ½йǷѹȽϣñ־λ
														                          // 															 	 0:Ӧĵؾͻڼģʽ²йǷѹȽϣñ־λ
											configDData[current_ic].gsel_m,//ģʽ£GPIO0~7Ƚѡ
											configDData[current_ic].isospi_wake_t,//isospi(ջSPI)ʱ䣬0:10us		1:20us
											configDData[current_ic].adc_rst_sel,//1ͨADCλѡ0:вͨλADC1:ֻе1ͨλADC֮2~nͨλADC
											configDData[current_ic].time_sel_m,//ģʽ£ʱʱãʱʱ=(TIME_SEL_M+1)*1s(2~64s)Сֵ1(2s)
											configDData[current_ic].adc_init_t2,//ADC2~nͨADCʼʱ䣬(ADC_INIT_T2+1)*20us(20~320us)
											configDData[current_ic].adc_init_t1,//ADC1ͨADCʼʱ(ADC_INIT_T1+1)*100us(100~1600us)
											configDData[current_ic].trim2_en,//޵2ʹܣ1:ʹܣ0:ʹ
											configDData[current_ic].trim1_en,//޵1ʹܣ1:ʹܣ0:ʹ
											configDData[current_ic].err_t_sel_m,//ģʽ·쳣ϱļʱ  00:200ms01:400ms10:600ms11:800ms
											configDData[current_ic].vd33t_on_m//ģʽ£VREF1VD33Tʱ(5+VD33T_ON_M*10)msΧ5~155ms
											);
	}
	
  for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴDָ
  {
    if (isospi_reverse == TRUE)//жѡľջͨŷԷ
    {
      c_ic = current_ic;//ѡüĴDָ
    }
    else
    {
      c_ic = total_ic - current_ic - 1;//ѡ򽫵üĴDָ
    }

    for (data = 0; data<6; data++)//isospiһֱΪFALSEѭüĴDúõһһд뷢Уͨ͸ÿ8915AоƬ
    {
      write_buffer[write_count] = configDArray[c_ic].tx_data[data];//дָ
      write_count++;
    }
  }
  BF8915A_write(total_ic, cmd, write_buffer);//дBF8915AдЧغݵͨú
}

/*!
    \brief      Reads the BF8915A CFGRA register(BF8915AüĴA)
		\param[in]  total_ic 	 : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configAData: A two dimensional array that the function stores the read configuration data(ú洢ȡݵĶά)
    \retval     pec_error
*/
uint8_t BF8915A_rdcfga(uint8_t total_ic, 
											 ConfigA_TypeDef configAData[]
											 )
{
  uint8_t cmd[2]= {0x00U, 0x05U};//ͶBF8915AüĴAָĸߵ͹16λ
	//Reg_TypeDef configAArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹA,ڴ洢ָ
  uint8_t read_buffer[256];//洢SPI˿ڶȡݵ
  uint8_t pec_error = 0;//
  uint16_t data_pec;//յÿüĴAеPEC()
  uint16_t calc_pec;//յÿüĴAָݵPEC()
  uint8_t c_ic = 0;//ǰڶ8915AоƬ
  uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  uint8_t byte=0;//ÿ8һѭڼÿĴAǰѭļĴԼPEC()

  pec_error = BF8915A_read(total_ic, cmd, read_buffer);//ִдBF8915AͶݣشǷȷ

  for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴAеָǷд
  {
    if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
      c_ic = current_ic;//ѡüĴAеָ
    }
    else
    {
      c_ic = total_ic - current_ic - 1;//ѡüĴAеָ
    }

    for (byte=0; byte<8; byte++)//isospiһֱΪFALSEѭյÿüĴеݺ2ֽPEC()дУյǵ8915AоƬ
    {
      configAArray[c_ic].rx_data[byte] = read_buffer[byte+(8*current_ic)];
    }
    calc_pec = pec15_calc(6,&read_buffer[8*current_ic]);//ջļĴ(68λĴ)еPEC()
    data_pec = read_buffer[7+(8*current_ic)] | (read_buffer[6+(8*current_ic)]<<8);//read_buffer[]нյPEC()ߵ͹16λdata_pec
    if (calc_pec != data_pec )//Ƿƥ
    {
      configAArray[c_ic].rx_pec_match = 1;//벻ȷ
    }
    else configAArray[c_ic].rx_pec_match = 0;//ȷ
  }
	for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴAеָ
	{
		configAData[current_ic].gpio_pd_en = configAArray[current_ic].rx_data[0];//CFGAR08λGPIOʹܣÿһλӦһIO
		configAData[current_ic].gpio_analog_en = configAArray[current_ic].rx_data[1];//CFGAR18λGPIO0~7ģʽѡ
		configAData[current_ic].rsvd2 = (BOOLEAN)((configAArray[current_ic].rx_data[2] & 0x08U) == 0x08U);//λԶ0
		configAData[current_ic].rsvd1 = (BOOLEAN)((configAArray[current_ic].rx_data[2] & 0x04U) == 0x04U);//λԶ0
		configAData[current_ic].osr_sel = (BOOLEAN)((configAArray[current_ic].rx_data[2] & 0x02U) == 0x02U);//CFGAR2ĵ2λ,ADCѡ
		configAData[current_ic].refon = (BOOLEAN)((configAArray[current_ic].rx_data[2] & 0x01U) == 0x01U);//CFGAR2ĵ1λ,VREF1(׼ѹ)
		configAData[current_ic].uv_th = (uint16_t)(configAArray[current_ic].rx_data[3]) + (((uint16_t)((configAArray[current_ic].rx_data[4])&0x0FU)) << 0x8U);
		                                                                                    //CFGAR38λCFGAR4ĵ4λ,CFGAR1ĵ4λ12~9λǷѹֵ
		configAData[current_ic].ov_th = (((uint16_t)configAArray[current_ic].rx_data[5]) << 0x4U)  + (((configAArray[current_ic].rx_data[4])&0xF0U) >> 0x4U);
		                                                                                    //CFGAR58λCFGAR4ĸ4λ,CFGAR4ĸ4λ12~9λѹֵ
		configAData[current_ic].rx_pec_match = configAArray[current_ic].rx_pec_match;//ÿüĴAеļǷƥ
	}
  return(pec_error);//شֵ
}

/*!
    \brief      Reads the BF8915A CFGRB register(BF8915AüĴB)
		\param[in]  total_ic 	 : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configBData: A two dimensional array that the function stores the read configuration data(ú洢ȡݵĶά)
    \retval     pec_error   	                  					  
*/
uint8_t BF8915A_rdcfgb(uint8_t total_ic, 
											 ConfigB_TypeDef configBData[]
											 )
{
  uint8_t cmd[2]= {0x00 , 0x06};//ͶBF8915AüĴBָĸߵ͹16λ
	//Reg_TypeDef configBArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹB,ڴ洢ָ
  uint8_t read_buffer[256];//洢SPI˿ڶȡ 
  uint8_t pec_error = 0;//
  uint16_t data_pec;//յÿüĴBеPEC()
  uint16_t calc_pec;//յÿüĴBָݵPEC()
  uint8_t c_ic = 0;//ǰڶ8915AоƬ
  uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  uint8_t byte=0; //ÿ8һѭڼÿĴBеǰѭļĴԼPEC()

  pec_error = BF8915A_read(total_ic, cmd, read_buffer);//ִдBF8915AͶݣشǷȷ

  for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴBеָǷд
  {
    if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
      c_ic = current_ic;//ѡüĴBеָ
    }
    else
    {
      c_ic = total_ic - current_ic - 1;//ѡüĴBеָ
    }

    for (byte=0; byte<8; byte++)//isospiһֱΪFALSEѭյÿüĴеݺ2ֽPEC()дУյǵ8915AоƬ
    {
      configBArray[c_ic].rx_data[byte] = read_buffer[byte+(8*current_ic)];
    }
    calc_pec = pec15_calc(6,&read_buffer[8*current_ic]);//ջļĴ(68λĴ)еPEC()
    data_pec = read_buffer[7+(8*current_ic)] | (read_buffer[6+(8*current_ic)]<<8);//read_buffer[]нյPEC()ߵ͹16λdata_pec
    if (calc_pec != data_pec )//Ƿƥ
    {
      configBArray[c_ic].rx_pec_match = 1;//벻ȷ
    }
    else configBArray[c_ic].rx_pec_match = 0;//ȷ
  }
	for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴBеָ
	{
		configBData[current_ic].dcc = (((uint16_t)configBArray[current_ic].rx_data[1]) << 0x8U) + configBArray[current_ic].rx_data[0];
		                                                                                          //CFGBR08λCFGBR18λ,CFGBR18λ8λŵؿ
		configBData[current_ic].bl_duty_sel = (configBArray[current_ic].rx_data[2] & 0xF0U) >> 0x4U;//CFGBR2ĸ4λ,ռձѡ
		configBData[current_ic].dcto = configBArray[current_ic].rx_data[2] & 0x0FU;//CFGBR2ĵ4λ,ŵ綨ʱֵ
		configBData[current_ic].vuv_bl_th = (uint16_t)configBArray[current_ic].rx_data[3] + (((uint16_t)(configBArray[current_ic].rx_data[4] & 0x0F)) << 0x8U);
		                                                                                         //CFGBR38λCFGBR4ĵ4λ,CFGBR1ĵ4λ12~9λǷѹֵ
		configBData[current_ic].dtmen = (BOOLEAN)((configBArray[current_ic].rx_data[4] & 0x10U) == 0x10U);//CFGBR4ĵ5λ,ʹܷŵ
		configBData[current_ic].rx_pec_match = configBArray[current_ic].rx_pec_match;//ÿüĴBеļǷƥ
	}
  return(pec_error);//شֵ
}

/*!
    \brief      Reads the BF8915A CFGRC register(BF8915AüĴC)
		\param[in]  total_ic 	 : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configCData: A two dimensional array that the function stores the read configuration data(ú洢ȡݵĶά)
    \retval     none   	                  					  
*/
uint8_t BF8915A_rdcfgc(uint8_t total_ic, 
											 ConfigC_TypeDef configCData[]
											 )
{
  uint8_t cmd[2]= {0x00 , 0x07};//ͶBF8915AüĴCָĸߵ͹16λ
	//Reg_TypeDef configCArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹC,ڴ洢ָ
  uint8_t read_buffer[256];//洢SPI˿ڶȡ 
  uint8_t pec_error = 0;//
  uint16_t data_pec;//յÿüĴCеPEC()
  uint16_t calc_pec;//յÿüĴCָݵPEC()
  uint8_t c_ic = 0;//ǰڶ8915AоƬ
  uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  uint8_t byte=0;//ÿ8һѭڼÿĴBеǰѭļĴԼPEC()

  pec_error = BF8915A_read(total_ic, cmd, read_buffer);//ִдBF8915AͶݣشǷȷ

  for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴCеָǷд
  {
    if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
      c_ic = current_ic;//ѡüĴCеָ
    }
    else
    {
      c_ic = total_ic - current_ic - 1;//ѡüĴCеָ
    }

    for (byte=0; byte<8; byte++)//isospiһֱΪFALSEѭյÿüĴеݺ2ֽPEC()дУյǵ8915AоƬ
    {
      configCArray[c_ic].rx_data[byte] = read_buffer[byte+(8*current_ic)];
    }
    calc_pec = pec15_calc(6,&read_buffer[8*current_ic]);//ջļĴ(68λĴ)еPEC()
    data_pec = read_buffer[7+(8*current_ic)] | (read_buffer[6+(8*current_ic)]<<8);//read_buffer[]нյPEC()ߵ͹16λdata_pec
    if (calc_pec != data_pec )//Ƿƥ
    {
      configCArray[c_ic].rx_pec_match = 1;//벻ȷ
    }
    else configCArray[c_ic].rx_pec_match = 0;//ȷ
  }
	for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴCеָ
	{
		configCData[current_ic].vuv_m_th = configCArray[current_ic].rx_data[0] + (((uint16_t)(configCArray[current_ic].rx_data[1] & 0x0F)) << 0x8U);
		                                                                                          //CFGCR08λCFGCR1ĵ4λ,CFGCR1ĵ4λ12~9λģʽ£Ƿѹֵ
		configCData[current_ic].vov_m_th = (((uint16_t)configCArray[current_ic].rx_data[2]) << 0x4U) + ((configCArray[current_ic].rx_data[1] & 0xF0) >> 0x04U);
		                                                                    //CFGCR1ĸ4λCFGCR28λ,CFGCR14λ4λCFGCR28λ12~5λģʽ£ѹֵ
		configCData[current_ic].itov_m_th  = configCArray[current_ic].rx_data[3] + (((uint16_t)(configCArray[current_ic].rx_data[4] & 0x0F)) << 0x8U);
		                                                                                          //CFGBC38λCFGCR1ĵ4λ,CFGCR4ĵ4λ12~9λģʽ£ڲֵ
		configCData[current_ic].extov_m_th = (((uint16_t)configCArray[current_ic].rx_data[5]) << 0x4U) + ((configCArray[current_ic].rx_data[4] & 0xF0) >> 0x04U);
		                                                                    //CFGCR4ĸ4λCFGCR58λ,CFGCR44λ4λCFGCR58λ12~5λģʽ£ⲿֵ
		configCData[current_ic].rx_pec_match = configCArray[current_ic].rx_pec_match;//ÿüĴCеļǷƥ
	}
  return(pec_error);//شֵ
}

/*!
    \brief      Reads the BF8915A CFGRD register(BF8915AüĴD)
		\param[in]  total_ic 	 : Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  configDData: A two dimensional array that the function stores the read configuration data(ú洢ȡݵĶά)
    \retval     none   	                  					  
*/
uint8_t BF8915A_rdcfgd(uint8_t total_ic, 
											 ConfigD_TypeDef configDData[]
											 )
{
  uint8_t cmd[2]= {0x00 , 0x08};//ͶBF8915AüĴDָĸߵ͹16λ
	//Reg_TypeDef configDArray[TOTAL_IC];//һṹΪReg_TypeDefݽṹD,ڴ洢ָ
  uint8_t read_buffer[256] = {0};//洢SPI˿ڶȡ 
  uint8_t pec_error = 0;//
  uint16_t data_pec;//յÿüĴDеPEC()
  uint16_t calc_pec;//յÿüĴDָݵPEC()
  uint8_t c_ic = 0;//ǰڶ8915AоƬ
  uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  uint8_t byte=0; //ÿ8һѭڼÿĴBеǰѭļĴԼPEC()

  pec_error = BF8915A_read(total_ic, cmd, read_buffer);//ִдBF8915AͶݣشǷȷ

  for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴDеָǷд
  {
    if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
      c_ic = current_ic;//ѡüĴDеָ
    }
    else
    {
      c_ic = total_ic - current_ic - 1;//ѡüĴDеָ
    }

    for (byte=0; byte<8; byte++)//isospiһֱΪFALSEѭյÿüĴеݺ2ֽPEC()дУյǵ8915AоƬ
    {
      configDArray[c_ic].rx_data[byte] = read_buffer[byte+(8*current_ic)];
    }
    calc_pec = pec15_calc(6,&read_buffer[8*current_ic]);//ջļĴ(68λĴ)еPEC()
    data_pec = read_buffer[7+(8*current_ic)] | (read_buffer[6+(8*current_ic)]<<8);//read_buffer[]нյPEC()ߵ͹16λdata_pec
    if (calc_pec != data_pec )//Ƿƥ
    {
      configDArray[c_ic].rx_pec_match = 1U;//벻ȷ
			pec_error = 1U;
    }
    else configDArray[c_ic].rx_pec_match = 0;//ȷ
  }
	for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪÿ8915AоƬüĴDеָ
	{
		configDData[current_ic].csel_m = (((uint16_t)configDArray[current_ic].rx_data[1]) << 0x8U) + configDArray[current_ic].rx_data[0];
		                                                                                          //CFGDR08λCFGDR18λ,CFGDR18λ8λģʽ£صѹȽѡ
		configDData[current_ic].gsel_m = configDArray[current_ic].rx_data[2];//CFGDR28λ,ģʽ£GPIO0~7Ƚѡ
		configDData[current_ic].isospi_wake_t = (BOOLEAN)((configDArray[current_ic].rx_data[3] & 0x80) == 0x80);//CFGDR3ĵ8λ,ջSPIĻʱ
		configDData[current_ic].adc_rst_sel = (BOOLEAN)((configDArray[current_ic].rx_data[3] & 0x40) == 0x40);//CFGDR3ĵ7λ,1ͨADCλѡ
		configDData[current_ic].time_sel_m = configDArray[current_ic].rx_data[3] & 0x3F;//CFGDR36~1λ,ģʽ£ʱʱ
		configDData[current_ic].adc_init_t2 = (configDArray[current_ic].rx_data[4] & 0xF0) >> 0x4U;//CFGDR4ĸ4λ,ADC2~nͨADCʼʱ
		configDData[current_ic].adc_init_t1 = configDArray[current_ic].rx_data[4] & 0x0F;//CFGDR4ĵ4λ,ADC1ͨADCʼʱ
		configDData[current_ic].trim2_en = (BOOLEAN)((configDArray[current_ic].rx_data[5] & 0x80) == 0x80U);//CFGDR5ĵ8λ,޵2ʹ
		configDData[current_ic].trim1_en = (BOOLEAN)((configDArray[current_ic].rx_data[5] & 0x40) == 0x40U);//CFGDR5ĵ7λ,޵1ʹ
		configDData[current_ic].err_t_sel_m = (configDArray[current_ic].rx_data[5] & 0x30) >> 0x4U; //CFGDR5ĵ6~5λ,ģʽ·쳣ϱļʱ
		configDData[current_ic].vd33t_on_m = configDArray[current_ic].rx_data[5] & 0x0F;//CFGDR5ĵ4λ,ģʽ£VREF1VD33Tʱ
		configDData[current_ic].rx_pec_match = configDArray[current_ic].rx_pec_match;//ÿüĴDеļǷƥ
	}
  return(pec_error);//شֵ
}

/*!
    \brief      ADCV CMD(صѹADCתָ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ:0123)
		\param[in]  DISCP : DISCP_DISABLEDISCP_ENABLE(ŵλ:ŵλд01)
		\param[in]  CSEL  : CSEL_CH_ALLCSEL_CH_1and9CSEL_CH_2and10CSEL_CH_3and11CSEL_CH_4and12
												             CSEL_CH_5and13CSEL_CH_6and14CSEL_CH_7and15CSEL_CH_8and16
   (ADCתĵѡ:е(0)19(1)210(2)311(3)412(4)
												             513(5)614(6)715(7)816(8))
    \retval     none   	                  					  
*/
void BF8915A_adcv(uint8_t CLKSEL,
									uint8_t OSR, 		
									uint8_t DISCP, 
									uint8_t CSEL
									)
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL2λ ı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_ADCV << 0x1U);//ָĸ8λ,#define CMD_ADCV	0x1U
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] = clksel_bits | (OSR<<5) | (DISCP<<4) | CSEL;//ָĵ8λ,ο ָ ADCV ָ
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      CVST CMD(صѹԲ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   : OSR_64 OSR_128OSR_2566OSR_512(ADCƵѡ:0123)
		\param[in]  SFTEST: SELFTEST_6666		SELFTEST_9999(Բģʽѡ:Բ1 Բ2)
    \retval     none   	                  				
*/  
void BF8915A_cvst(uint8_t CLKSEL, 
									uint8_t OSR,    
									uint8_t SFTEST 
									)
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL2λ ı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_CVST << 0x1U);//ָĸ8λ,#define CMD_CVST	0x03U
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] =  clksel_bits | (OSR<<5) | (SFTEST<<4);//ָĵ8λ,ο ָ CVST ָ		
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      ADOL CMD(صԪָ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ:0123)
		\param[in]  DISCP : DISCP_DISABLEDISCP_ENABLE	(ŵλ:ŵλд01)
    \retval     none   		                  				  
*/
void BF8915A_adol(uint8_t CLKSEL,
									uint8_t OSR,
									uint8_t DISCP
									)
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL2λ ı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_ADOL << 0x1U);//ָĸ8λ,#define CMD_ADOL	0x04U
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] =  clksel_bits | (OSR<<5) | (DISCP<<4) | 0x01U;//ָĵ8λ,ο ָ ADOL ָ		
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
        \brief      ADGP CMD(GPIO ADCתָ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ)
		\param[in]  GSEL 	: GSEL_CH_ALL	 GSEL_CH_GPIO0GSEL_CH_GPIO1GSEL_CH_GPIO2GSEL_CH_GPIO3	
												GSEL_CH_VD33TGSEL_CH_GPIO4GSEL_CH_GPIO5GSEL_CH_GPIO6GSEL_CH_GPIO7
  (ADCתGPIOѡ :GPIO0~GPIO7,VD33TGPIO0GPIO1GPIO2GPIO3	
											                 VD33TGPIO4GPIO5GPIO6GPIO7)

    \retval     none   	                  				  
*/
void BF8915A_adgp(uint8_t CLKSEL,
									uint8_t OSR,   
									uint8_t GSEL
									)
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL2λ ı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_ADGP << 0x1U);//ָĸ8λ,#define CMD_ADGP	0x05U
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] =  clksel_bits | (OSR<<5) | GSEL;//ָĵ8λ,ο ָ ADGP ָ			
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      GPST CMD(GPIOԲָ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ:0123)
		\param[in]  SFTEST: SELFTEST_6666		SELFTEST_9999(Բģʽѡ:Բ1 Բ2)
    \retval     none   	                  				
*/  
void BF8915A_gpst(uint8_t CLKSEL, 
									uint8_t OSR,    
									uint8_t SFTEST 
									)
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL2λ ı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_GPST << 0x1U);//ָĸ8λ,#define CMD_GPST	0x07U
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] =  clksel_bits | (OSR<<5) | (SFTEST<<4);//ָĵ8λ,ο ָ GPST ָ	
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      ADSTAT CMD(ڲ豸ָ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ:0123)
		\param[in]  STSEL : STATASTATBSTATCSTATD(ADCתڲѡ)
    \retval     none   	                  				
*/                                  
void BF8915A_adstat(uint8_t CLKSEL, 
										uint8_t OSR,   
										uint8_t STSEL
										)
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL2λ ı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_ADSTAT << 0x1U);//ָĸ8λ,#define CMD_ADSTAT	0x08U
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] =  clksel_bits | (OSR<<5) | STSEL;//ָĵ8λ,ο ָ ADSTAT ָ	
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      STATST CMD(Բڲ豸ָ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ:0123)
		\param[in]  SFTEST: SELFTEST_6666		SELFTEST_9999(Բģʽѡ:Բ1 Բ2)
    \retval     none   	                  				
*/  
void BF8915A_statst(uint8_t CLKSEL,
										uint8_t OSR,    
										uint8_t SFTEST 
										)
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL λ ı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_STATST << 0x1U);//ָĸ8λ,#define CMD_STATST	0x09U
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] =  clksel_bits | (OSR<<5) | (SFTEST<<4);//ָĵ8λ,ο ָ CMD_STATST ָ
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      ADCVGP CMD(صѹGPIOָ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ:0123)
		\param[in]  DISCP : DISCP_DISABLEDISCP_ENABLE(ŵλ:ŵλд01)
    \retval     none   	                  				
*/  
void BF8915A_adcvgp(uint8_t CLKSEL, 
										uint8_t OSR,    
										uint8_t DISCP
										)
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL2λ ı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_ADCVGP << 0x1U);//ָĸ8λ,#define CMD_ADCVGP	0x0aU
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] =  clksel_bits | (OSR<<5) | (DISCP<<4);//ָĵ8λ,ο ָ CMD_ADCVGP ָ
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      MNT CMD(ָ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   : OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ:0123)
		\param[in]  MNMOD : MNMOD_DISABLEMNMOD_1MNMOD_2MNMOD_3(ģʽѡ:ģʽָЧ(00)ģʽ1(01)ģʽ2(02)ģʽ3(03))
		\param[in]  STRMN : STRMN_ENABLESTRMN_DISABLE(ģʽʹ:ģʽ(1)رռģʽ(2))
		\param[in]  BLEN  : BLEN_ONBLEN_OFF	(⿪ܿź2:ر(0)(1))
    \retval     none                     				
*/                                       				
void BF8915A_mnt(uint8_t CLKSEL,     				
								 uint8_t OSR,    
								 uint8_t MNMOD,
								 uint8_t STRMN,
								 uint8_t BLEN
								 )
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL2 λı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_MNT << 0x1U);//ָĸ8λ,#define CMD_MNT	0x0cU
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] =  clksel_bits | (OSR<<5) | (MNMOD<<3) | (STRMN << 2) | BLEN ;//ָĵ8λ,ο ָ CMD_MNT ָ
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      STRBL CMD(ָ)
		\param[in]  CLKSEL: CLKSEL_2M
		\param[in]  OSR   :	OSR_64 OSR_128OSR_256OSR_512(ADCƵѡ)
		\param[in]  OESEL :	OESEL_ODDOESEL_EVEN	(ŵżѡ:(0)ż(1))
		\param[in]  BLEN  : BLEN_ONBLEN_OFF(⿪ܿź 2:(1)ر(0))
    \retval     none                     
*/                      
void BF8915A_strbl(uint8_t CLKSEL, 
									 uint8_t OSR,    
									 uint8_t OESEL,
									 uint8_t BLEN
									 )
{
	uint8_t cmd[2] = {0U};//ʼcmd[]
	uint8_t clksel_bits = 0x0U;//CLKSEL2λ ı
	clksel_bits = (CLKSEL & 0x02) >> 1;//CLKSEL[1]
	cmd[0] = clksel_bits + (CMD_STRBL << 0x1U);//ָĸ8λ,#define CMD_STRBL	0x0dU
	clksel_bits = (CLKSEL & 0x01) << 7;//CLKSEL[0]
	cmd[1] =  clksel_bits | (OSR<<5) | (OESEL<<4) | BLEN;//ָĵ8λ,ο ָ CMD_STRBL ָ
	BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}


/*!
    \brief      Reads the raw cell voltage register data(ȡԭʼصѹĴ)
		\param[in]  reg     : Determines which  register is read back(ȷضĸصѹĴ)
		\param[in]  total_ic: the Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  cellData: Array of the unparsed codes(δ)
    \retval     none
*/
void BF8915A_rdcv_reg(uint8_t reg, //Determines which cell voltage register is read back(ȷضĸصѹĴ)
                      uint8_t total_ic,
                      uint8_t *cellData 
                     )
{
  const uint8_t REG_LEN = 8; //number of 6 bytes in each ICs register + 2 bytes for the PEC(ÿɵ·Ĵе6ֽPEC()2ֽ)
  uint8_t cmd[4];//ʼcmd[]
  uint16_t cmd_pec;//ָPEC() 
  cmd[0] = 0x00;//ָĸ8λ
	cmd[1] = reg + 0x08U;//ָĵ8λ8915A.hļ صѹĴӦ
  cmd_pec = pec15_calc(2, cmd);//ָPEC()
  cmd[2] = (uint8_t)(cmd_pec >> 8);//ָPEC()ĸ߰λ
  cmd[3] = (uint8_t)(cmd_pec);//ָPEC()ĵͰλ

	if (isospi_reverse == FALSE)//жѡľջͨŷԷ
  {
    cs_low();//ƬѡCSΪ͵ƽ
    spi_write_read(cmd,4,cellData,(REG_LEN*total_ic));//ʹSPI˿дͶȡ趨ֽ
    cs_high();//ƬѡCSΪߵƽ
  }
  else
  {
    cs_low_reverse();//ƬѡCSΪ͵ƽ
    spi_write_read(cmd,4,cellData,(REG_LEN*total_ic));//ʹSPI˿дͶȡ趨ֽ
    cs_high_reverse();//ƬѡCSΪߵƽ
  }
}

/*!
    \brief      reads BF8915A GPIO registers(ȡBF8915AGPIOĴ)
                The function reads a single GPIO voltage register and stores the read data in the *data point as a byte array. 
                This function is rarely used outside of the BF8915A_rdgv() command.
               (úȡGPIOѹĴȡΪֽ洢*dataС˹ܺBF8915A_rdgv()֮ʹá)
		\param[in]  reg     : Determines which  register is read back(ȷضĸصѹĴ)
		\param[in]  total_ic: the Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  gpioData: Array of the unparsed codes(δ)
    \retval     none
*/
void BF8915A_rdgv_reg(uint8_t reg, 
                      uint8_t total_ic, 
                      uint8_t *gpioData 
                      )
{
  const uint8_t REG_LEN = 8; // number of 6 bytes in the register + 2 bytes for the PEC(Ĵе6ֽPEC()2ֽ)
  uint8_t cmd[4];//ʼcmd[]
  uint16_t cmd_pec;//ָPEC()
	cmd[0] = 0x00;//ָĸ8λ
  cmd[1] = reg + 0x0EU;//ָĵ8λ8915A.hļ GPIOGѹ
  cmd_pec = pec15_calc(2, cmd);//ָPEC()
  cmd[2] = (uint8_t)(cmd_pec >> 8);//ָPEC()ĸ߰λ
  cmd[3] = (uint8_t)(cmd_pec);//ָPEC()ĵͰλ
	
	if (isospi_reverse == FALSE)//жѡľջͨŷԷ
  {
    cs_low();//ƬѡCSΪ͵ƽ
    spi_write_read(cmd,4,gpioData,(REG_LEN*total_ic));//ʹSPI˿дͶȡ趨ֽ
    cs_high();//ƬѡCSΪߵƽ
  }
  else
  {
    cs_low_reverse();//ƬѡCSΪ͵ƽ
    spi_write_read(cmd,4,gpioData,(REG_LEN*total_ic));//ʹSPI˿дͶȡ趨ֽ
    cs_high_reverse();//ƬѡCSΪߵƽ
  }
}

/*!
    \brief      Reads BF8915A stat registers(ȡBF8915A״̬Ĵ)
		\param[in]  reg     : Determines which register is read back(ȷضĸĴ)
		\param[in]  total_ic: the Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  statData: Array of the unparsed codes(δ)
    \retval     none
*/
void BF8915A_rdstat_reg(uint8_t reg, 
                        uint8_t total_ic, 
                        uint8_t *statData 
												)
{
  const uint8_t REG_LEN = 8;//number of 6 bytes in the register + 2 bytes for the PEC(Ĵе6ֽPEC()2ֽ)
  uint8_t cmd[4];//ʼcmd[]
  uint16_t cmd_pec;//ָPEC()
	cmd[0] = 0x00;//ָĸ8λ
  cmd[1] = reg + 0x11;//ָĵ8λ8915A.hļ ״̬ĴRDSTAT
  cmd_pec = pec15_calc(2, cmd);//ָPEC()
  cmd[2] = (uint8_t)(cmd_pec >> 8);//ָPEC()ĸ߰λ
  cmd[3] = (uint8_t)(cmd_pec);//ָPEC()ĵͰλ

	if (isospi_reverse == FALSE)//жѡľջͨŷԷ
  {
    cs_low();//ƬѡCSΪ͵ƽ
    spi_write_read(cmd,4,statData,(REG_LEN*total_ic));//ʹSPI˿дͶȡ趨ֽ
    cs_high();//ƬѡCSΪߵƽ
  }
  else
  {
    cs_low_reverse();//ƬѡCSΪ͵ƽ
    spi_write_read(cmd,4,statData,(REG_LEN*total_ic));//ʹSPI˿дͶȡ趨ֽ
    cs_high_reverse();//ƬѡCSΪߵƽ
  }
}

/*!
    \brief      Helper function that parses voltage measurement registers(ѹĴĸ)
		\param[in]  current_ic: Number of ics in current cycle(ǰѭIC(8915A))
		\param[in]  cell_reg  : Controls which cell voltage register is read back(ƻضĸѹĴ)
		\param[in]  cell_data : Number of bytes of data received(յݵֽ6+2PEC())
		\param[in]  cell_codes: cell voltage value(صѹֵ)
		\param[in]  ic_pec    : If a PEC error was detected during most recent read cmd(Ķȡcmd(ָ)ڼ⵽PEC())
    \retval     pec_error
*/
uint8_t parse_cells(uint8_t current_ic, 
										uint8_t cell_reg, 
										uint8_t cell_data[], 
										uint16_t *cell_codes, 
										uint8_t *ic_pec
										)
{
  const uint8_t BYT_IN_REG = 6;//Ĵе68λĴ
  uint8_t CELL_IN_REG = 3;//ÿѹĴе 3ѹֵ
  uint8_t pec_error = 0;//
  uint16_t parsed_cell;//ѹֵ
  uint16_t received_pec;//յÿĴеPEC()
  uint16_t data_pec;//յÿĴָݵPEC()
  uint8_t data_counter = current_ic*NUM_RX_BYT; //data counter(ݼ)
	uint8_t current_cell = 0;//ÿѹĴ鵱ǰѭĵصѹ
	
  for (current_cell = 0; current_cell < CELL_IN_REG; current_cell++)  // This loop parses the read back data into cell voltages, it loops once for each of the 3 cell voltage codes in the register
  {																																		//(ѭصݽɵѹԼĴеÿ3ѹѭһ)
    parsed_cell = cell_data[data_counter] + ((uint16_t)cell_data[data_counter + 1] << 8);//Each cell codes is received as two bytes and is combined to create the parsed cell voltage code
		                                                                           //(ÿѹ뱻ΪֽڣұԴĵѹ)
    cell_codes[current_cell  + ((cell_reg - 1) * CELL_IN_REG)] = parsed_cell;//ĵѹδcell_codes[]	 	 
    data_counter = data_counter + 2;//Because cell voltage codes are two bytes the data counter must increment by two for each parsed cell code
																		//(ΪѹֽڣԶÿĵ룬ݼ2)
		if(cell_reg == CVFR)//#define CVFR	0x06U
		{
			current_cell = 0x3U;//ŵصѹĽṹ16Ԫأ˴Ϊ˷ֹCVFR(صѹĴF)ʱ
		}
  }
	if(cell_reg == CVFR)//ĴΪCVFRֻѭһμѭ
	{
		data_counter = data_counter + 4;
	}
  received_pec = (cell_data[data_counter] << 8) | cell_data[data_counter+1]; //The received PEC for the current_ic is transmitted as the 7th and 8th after the 6 cell voltage data bytes
																																						 //(յcurrent_ic(ǰIC(8915A))PEC()Ϊ6ѹֽ֮ĵ7͵8ֽڷ)
  data_pec = pec15_calc(BYT_IN_REG, &cell_data[(current_ic) * NUM_RX_BYT]);//ջļĴ(68λĴ)еPEC()

  if (received_pec != data_pec)//Ƿƥ
  {
    pec_error = 1;     //The pec_error variable is simply set 1 if any PEC errors(κpecpec_error򵥵Ϊ1)
    ic_pec[cell_reg-1]=1;//cellVoltage[c_ic].pec_match[0]еֵ1
  }
  else
  {
    ic_pec[cell_reg-1]=0;//ȷcellVoltage[c_ic].pec_match[0]еֵ0
  }
  data_counter=data_counter+2;//Because the transmitted PEC code is 2 bytes long the data_counter must be incremented by 2 bytes to point to the next ICs state voltage data
														  //(ΪPEC()2ֽڳݼ2ֽڲָһ8915A״̬ѹ)
  return(pec_error);//شֵ
}

/*!
    \brief      Reads and parses the BF8915A cell voltage registers(ȡBF8915AصѹĴ)
		\param[in]  reg                : Controls which cell voltage register is read back(ƻضĸصѹĴ)
		\param[in]  total_ic           : the Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  CellVoltage_TypeDef: CellVoltage Struct(صѹṹ)
    \retval     the time of pec_error(pec_error)
*/
uint8_t BF8915A_rdcv(uint8_t reg, 
                     uint8_t total_ic, 
                     CellVoltage_TypeDef *cellVoltage 
                    )
{
  uint8_t pec_error = 0;//
  uint8_t *cell_data;//ʼһ8λָcell_data
  uint8_t c_ic = 0;//ǰڶ8915AоƬ
	uint8_t cell_reg = 1;//صѹĴ
	uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  cell_data = (uint8_t *) malloc((NUM_RX_BYT*total_ic)*sizeof(uint8_t));//#define NUM_RX_BYT 0x8U(յݵֽ6ֽ+2PEC()ֽ)

  if (reg == 0)//ѡȡеصѹ
  {
    for (cell_reg = 1; cell_reg < NUM_CV_REG + 1; cell_reg++) //#define NUM_CV_REG 6U,ÿBF8915AصѹĴִһ
    {
      BF8915A_rdcv_reg(cell_reg, total_ic,cell_data );//ȡԭʼصѹĴ
      for (current_ic = 0; current_ic < total_ic; current_ic++)//ѭΪȡÿBF8915AѡĵصѹĴ
      {
        if (isospi_reverse == FALSE)//жѡľջͨŷԷ
        {
          c_ic = current_ic;//ѡ򽫵صѹ
        }
        else
        {
          c_ic = total_ic - current_ic - 1;//ѡ򽫵صѹ
        }
        pec_error = pec_error + parse_cells(current_ic,cell_reg, cell_data,
                                            &cellVoltage[c_ic].cellVoltage[0],
                                            &cellVoltage[c_ic].pec_match[0]);//ѹĴĸ,شֵ
      }
    }
   }

  else//ѡȡеصѹ
  {
    BF8915A_rdcv_reg(reg, total_ic,cell_data);//ȡԭʼصѹĴ

    for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪȡÿBF8915AѡĵصѹĴ
    {
      if (isospi_reverse == FALSE)//жѡľջͨŷԷ
      {
        c_ic = current_ic;//ѡ򽫵صѹ
      }
      else
      {
        c_ic = total_ic - current_ic - 1;//ѡ򽫵صѹ
      }
      pec_error = pec_error + parse_cells(current_ic,reg, cell_data,
                                          &cellVoltage[c_ic].cellVoltage[0],
                                          &cellVoltage[c_ic].pec_match[0]);//ѹĴĸ,شֵ
    }
  }
  free(cell_data);//ָ
  return(pec_error);//شֵ
}

/*!
    \brief      Reads and parses the BF8915A GPIO registers(ȡBF8915A GPIOĴ)
		\param[in]  reg        : Determines which GPIO voltage register is read back(ȷضĸGPIOѹĴ)
		\param[in]  total_ic   : the Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  gpioVoltage: A two dimensional array of the gpio voltage codes(GPIOѹĶά)
    \retval     pec_error
*/
uint8_t BF8915A_rdgv(uint8_t reg, 		 						
										 uint8_t total_ic,
										 GPIOReg_TypeDef *gpioVoltage
										 )
{
  uint8_t *dataPtr;//ʼһ8λָdataPtr
  uint8_t pec_error = 0;//
  uint8_t c_ic =0;//ǰڶ8915AоƬ
	uint8_t gpio_reg = 1;//GPIOĴ
	uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
  dataPtr = (uint8_t *) malloc((NUM_RX_BYT*total_ic)*sizeof(uint8_t));//ָdataPtrҪյĳ
	                                                                    //#define NUM_RX_BYT 0x8U(յݵֽ6ֽ+2PEC()ֽ)
  if (reg == 0)//ѡȡGPIOѹĴ
  {
    for (gpio_reg = 1; gpio_reg < NUM_GOIO_REG + 1; gpio_reg++) //#define NUM_STAT_REG	3U,ÿBF8915AGPIOѹĴִһ
    {
      BF8915A_rdgv_reg(gpio_reg, total_ic,dataPtr);//Reads the raw gpio register data into the data[] array(ԭʼGPIOĴݶdata[])
      for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪȡÿBF8915AѡGPIOѹĴ
      {
        if (isospi_reverse == FALSE)//жѡľջͨŷԷ
        {
          c_ic = current_ic;//ѡGPIOѹ
        }
        else
        {
          c_ic = total_ic - current_ic - 1;//ѡGPIOѹ
        }
        pec_error = parse_cells(current_ic,gpio_reg, dataPtr,
                                &gpioVoltage[c_ic].gpioVoltage[0],
                                &gpioVoltage[c_ic].pec_match[0]);//ѹĴĸ,شֵ
      }
    }
  }
  else//ѡȡGPIOѹĴ
  {
    BF8915A_rdgv_reg(reg, total_ic, dataPtr);//Reads the raw gpio register data into the data[] array(ԭʼGPIOĴݶdata[])

    for (current_ic = 0; current_ic<total_ic; current_ic++)//ѭΪȡÿBF8915AѡGPIOѹĴ
    {
      if (isospi_reverse == FALSE)//жѡľջͨŷԷ
      {
        c_ic = current_ic;//ѡGPIOѹ
      }
      else
      {
        c_ic = total_ic - current_ic - 1;//ѡGPIOѹ
      }
      pec_error = parse_cells(current_ic,reg, dataPtr,
                              &gpioVoltage[c_ic].gpioVoltage[0],
                              &gpioVoltage[c_ic].pec_match[0]);//ѹĴĸ,شֵ
    }

  }
  free(dataPtr);//ָ
  return (pec_error);//شֵ
}

/*!
    \brief      Reads and parses the BF8915A stat registers(ȡͽBF8915A״̬Ĵ)
		\param[in]  reg             : Determines which Stat register is read back(ȷضĸ״̬Ĵ)
		\param[in]  total_ic        : the Number of ICs in the system(ϵͳIC(8915A))
		\param[in]  StateReg_TypeDef: A two dimensional array of the state codes(״̬ĴĶά)
    \retval     pec_error
*/
uint8_t BF8915A_rdstat(uint8_t reg, 		 					
											 uint8_t total_ic,					
											 StateReg_TypeDef *stateReg
											 )

{
  const uint8_t BYT_IN_REG = 6;//Ĵе68λĴ
  const uint8_t GPIO_IN_REG = 3;//ÿĴе 3ѹֵ

  uint8_t *dataPtr;//ʼһ8λָdataPtr
  uint8_t data_counter = 0;//data counter(ݼ)
  uint8_t pec_error = 0;//
  uint16_t parsed_stat;//״ֵ̬
  uint16_t received_pec;//յÿĴеPEC()
  uint16_t data_pec;//յÿĴָݵPEC()
  uint8_t c_ic = 0;//ǰڶ8915AоƬ
	uint8_t stat_reg = 1;//ǰڶȡ״̬Ĵ
	uint8_t current_ic = 0;//current_ic is used as the IC counter(ǰIC(8915A)IC(8915A))
	uint8_t current_gpio = 0;//ǰڶĵѹֵ
	uint8_t stateD_byte = 0;//״̬Ĵֽڼ
	uint8_t stateD_bit = 0;//״̬Ĵλ
  dataPtr = (uint8_t *) malloc((NUM_RX_BYT*total_ic)*sizeof(uint8_t));//ָdataPtrҪյĳ

  if (reg == 0)//ѡȡ״̬Ĵ
  {
    for (stat_reg = 1; stat_reg < NUM_STAT_REG + 0x1U; stat_reg++)//#define NUM_STAT_REG	4U,ÿBF8915A״̬ѹĴִһ
    {
      data_counter = 0;//data counter(ݼ)
      BF8915A_rdstat_reg(stat_reg, total_ic,dataPtr);//Reads the raw status register data into the dataPtr[] array(ԭʼ״̬ĴݶdataPtr[])

      for (current_ic = 0 ; current_ic < total_ic; current_ic++)//ѭΪȡÿBF8915Aѡ״̬ѹĴ
      {
        if (isospi_reverse == FALSE)//жѡľջͨŷԷ
        {
          c_ic = current_ic;//ѡ״̬Ĵ
        }
        else
        {
          c_ic = total_ic - current_ic - 1;//ѡ״̬Ĵ
        }
        if ((stat_reg > 0) && (stat_reg < 4))//ȡļĴΪSTATASTATBSTATC
        {
          for (current_gpio = 0; current_gpio < GPIO_IN_REG; current_gpio++) // This loop parses the read back data into state voltages, it loops once for each of the 3 state voltage codes in the register
          {                                                                  //(ѭصݽΪ״̬ѹԼĴе3״̬ѹеÿһѭһ)			              
            parsed_stat = dataPtr[data_counter] + (dataPtr[data_counter+1]<<8);//Each state codes is received as two bytes and is combined to create the parsed state voltage code
						                                                                   //(ÿ״̬뱻Ϊֽڣұ״̬ѹ)
            stateReg[c_ic].stat_codes[current_gpio + (stat_reg - 1) * GPIO_IN_REG] = parsed_stat;//ĵѹδstateReg[c_ic].stat_codes[]	 	 
            data_counter=data_counter+2;//Because cell voltage codes are two bytes the data counter must increment by two for each parsed cell code
																	    	//(ΪѹֽڣԶÿĵ룬ݼ2)                                 	  
						if((reg == STATC) &&(current_gpio == 0x1U))	//˴жδ˷ֹSTATCʱ,StateReg_TypeDefṹstat_codes[]
						{
							current_gpio = GPIO_IN_REG;//ĴΪSTATCѾѭڶΣһѭ
							data_counter = data_counter+2;//Because cell voltage codes are two bytes the data counter must increment by two for each parsed cell code
																		        //(ΪѹֽڣԶÿĵ룬ݼ2)
						}
          }
        }
        else if (stat_reg == 4)//ȡļĴΪSTATD
        {
          stateReg[c_ic].uvOvFlags[0] = dataPtr[data_counter++];//STDR08λCell1~Cell4Ƿ/ѹ־
					stateReg[c_ic].uvOvFlags[1] = dataPtr[data_counter++];//STDR18λCell5~Cell8Ƿ/ѹ־
					stateReg[c_ic].uvOvFlags[2] = dataPtr[data_counter++];//STDR28λCell9~Cell12Ƿ/ѹ־
					stateReg[c_ic].uvOvFlags[3] = dataPtr[data_counter++];//STDR38λCell12~Cell16Ƿ/ѹ־
					stateReg[c_ic].cfg_err = ((dataPtr[data_counter] & 0x40) >> 0x6U);//STDR4ĵ7λУ־(żУECCУ)
					stateReg[c_ic].pec_err = ((dataPtr[data_counter] & 0x20) >> 0x5U);//STDR4ĵ6λָݵPECУ־
					stateReg[c_ic].extov = ((dataPtr[data_counter] & 0x10) >> 0x4U);//STDR4ĵ5λģʽ£ⲿ¶(gpio)±־
					stateReg[c_ic].itov = ((dataPtr[data_counter] & 0x08) >> 0x3U);//STDR4ĵ4λģʽ£ڲ¶(vtemp)±־
					stateReg[c_ic].htov2 = ((dataPtr[data_counter] & 0x04) >> 0x2U);//STDR4ĵ3λӲ¶(95)±־
					stateReg[c_ic].htov1 = ((dataPtr[data_counter] & 0x02) >> 0x1U);//STDR4ĵ2λӲ¶(125)±־
					stateReg[c_ic].mux_fail = (dataPtr[data_counter++] & 0x01);//STDR4ĵ1λԽ
					stateReg[c_ic].mode_state = ((dataPtr[data_counter] & 0xC0U) >> 0x6U);//STDR5ĵ8~7λģʽ״̬Ĵ
					stateReg[c_ic].rst_state = (dataPtr[data_counter++] & 0x3FU);//STDR5ĵ6~1λλ־Ĵ
				
					stateReg[c_ic].cellOvFlag = 0x00U;//Ƿѹ־λÿλ־ÿصǷѹ־λ
					stateReg[c_ic].cellUvFlag = 0x00U;//عѹ־λÿλ־ÿصĹѹ־λ
					
					for(stateD_byte = 0;stateD_byte < 4;stateD_byte ++)//״̬Ĵֽѭ
					{
						for(stateD_bit = 0;stateD_bit < 4;stateD_bit ++)//״̬Ĵλѭ
						{
							if((stateReg[c_ic].uvOvFlags[stateD_byte] & (0x01 << (stateD_bit * 0x2U))) == (0x01 << stateD_bit * 0x2U))//жϸCellxǷѹ־λǷΪ1
								stateReg[c_ic].cellUvFlag |= 0x0001 << ((stateD_byte * 0x4U) + stateD_bit);//CellxǷѹ־λ1
							else
								stateReg[c_ic].cellUvFlag &= ~(0x0001 << ((stateD_byte * 0x4U) + stateD_bit));//CellxǷѹ־λ0
							
							if((stateReg[c_ic].uvOvFlags[stateD_byte] & (0x01 << (stateD_bit * 0x2U + 0x1U))) == (0x01 << (stateD_bit * 0x2U + 0x1U)))//жϸCellxĹѹ־λǷΪ1
								stateReg[c_ic].cellOvFlag |= 0x0001 << ((stateD_byte * 0x4U) + stateD_bit);//CellxĹѹ־λ1
							else
								stateReg[c_ic].cellOvFlag &= ~(0x0001 << ((stateD_byte * 0x4U) + stateD_bit));//CellxĹѹ־λ0
						}
					}					
        }
        received_pec = (dataPtr[data_counter]<<8)+ dataPtr[data_counter+1];//յĵǰIC(8915A)PEC()Ϊ6״̬ѹֽ֮ĵ7͵8ֽڷ																	 
        data_pec = pec15_calc(BYT_IN_REG, &dataPtr[current_ic*NUM_RX_BYT]);//ջļĴ(68λĴ)еPEC()

        if (received_pec != data_pec)//Ƿƥ
        {
          pec_error = 1; //κPEC()pec_error򵥵Ϊ1
          stateReg[c_ic].pec_match[stat_reg-1]=1;//stateReg[c_ic].pec_match[stat_reg-1]еļֵ1      
        }
        else
        {
          stateReg[c_ic].pec_match[stat_reg-1]=0;//stateReg[c_ic].pec_match[stat_reg-1]еļֵ0
        }
        data_counter = data_counter + 2;//Because the transmitted PEC code is 2 bytes long the data_counter must be incremented by 2 bytes to point to the next ICs state voltage data
																		    //(ΪPEC()2ֽڳݼ2ֽڲָһɵ·״̬ѹ)
      }
    }
  }
  else
  {
    BF8915A_rdstat_reg(reg, total_ic, dataPtr);//Reads the raw status register data into the dataPtr[] array(ԭʼ״̬ĴݶdataPtr[])
    for (current_ic = 0 ; current_ic < total_ic; current_ic++) //ѭΪȡÿBF8915Aѡ״̬ѹĴ
		{
      if (isospi_reverse == FALSE)//жѡľջͨŷԷ
      {
        c_ic = current_ic;//ѡ򽫵صѹ
      }
      else
      {
        c_ic = total_ic - current_ic - 1;//ѡ򽫵صѹ
      }
      if ((reg > 0) && (reg <4))//ȡļĴΪSTATASTATBSTATC
      {
        for (current_gpio = 0; current_gpio< GPIO_IN_REG; current_gpio++) //This loop parses the read back data into state voltages, it loops once for each of the 3 state voltage codes in the register
        {																		                              //(ѭصݽΪ״̬ѹԼĴе3״̬ѹеÿһѭһ)
          
          parsed_stat = dataPtr[data_counter] + (dataPtr[data_counter+1]<<8);//Each state codes is received as two bytes and is combined to create the parsed state voltage code
																					                                   //(ÿ״̬뱻Ϊֽڣұ״̬ѹ)
          stateReg[c_ic].stat_codes[current_gpio + (reg - 1) * GPIO_IN_REG] = parsed_stat;
          data_counter = data_counter+2;//Because state voltage codes are two bytes the data counter must increment by two for each parsed state voltage code
																			  //(Ϊ״̬ѹֽڣԶÿ״̬ѹ룬ݼ2)
					if((reg == STATC) &&(current_gpio == 0x1U))	//˴жδ˷ֹSTATCʱ,StateReg_TypeDefṹstat_codes[]
					{
						current_gpio = GPIO_IN_REG;//ĴΪSTATCѾѭڶΣһѭ
						data_counter = data_counter+2;//Because cell voltage codes are two bytes the data counter must increment by two for each parsed cell code
																		      //(ΪѹֽڣԶÿĵ룬ݼ2)
					}
        }
      }
      else if (reg == 4)//ȡļĴΪSTATD
      {
          stateReg[c_ic].uvOvFlags[0] = dataPtr[data_counter++];//STDR08λCell1~Cell4Ƿ/ѹ־
					stateReg[c_ic].uvOvFlags[1] = dataPtr[data_counter++];//STDR18λCell5~Cell8Ƿ/ѹ־
					stateReg[c_ic].uvOvFlags[2] = dataPtr[data_counter++];//STDR28λCell9~Cell12Ƿ/ѹ־
					stateReg[c_ic].uvOvFlags[3] = dataPtr[data_counter++];//STDR38λCell12~Cell16Ƿ/ѹ־
					stateReg[c_ic].cfg_err = ((dataPtr[data_counter] & 0x40) >> 0x6U);//STDR4ĵ7λУ־(żУECCУ)
					stateReg[c_ic].pec_err = ((dataPtr[data_counter] & 0x20) >> 0x5U);//STDR4ĵ6λָݵPECУ־
					stateReg[c_ic].extov = ((dataPtr[data_counter] & 0x10) >> 0x4U);//STDR4ĵ5λģʽ£ⲿ¶(gpio)±־
					stateReg[c_ic].itov = ((dataPtr[data_counter] & 0x08) >> 0x3U);//STDR4ĵ4λģʽ£ڲ¶(vtemp)±־
					stateReg[c_ic].htov2 = ((dataPtr[data_counter] & 0x04) >> 0x2U);//STDR4ĵ3λӲ¶(95)±־
					stateReg[c_ic].htov1 = ((dataPtr[data_counter] & 0x02) >> 0x1U);//STDR4ĵ2λӲ¶(125)±־
					stateReg[c_ic].mux_fail = (dataPtr[data_counter++] & 0x01);//STDR4ĵ1λԽ
					stateReg[c_ic].mode_state = ((dataPtr[data_counter] & 0xC0U) >> 0x6U);//STDR5ĵ8~7λģʽ״̬Ĵ
					stateReg[c_ic].rst_state = (dataPtr[data_counter++] & 0x3FU);//STDR5ĵ6~1λλ־Ĵ				
					for(stateD_byte = 0;stateD_byte < 4;stateD_byte ++)//״̬Ĵֽѭ
					{
						for(stateD_bit = 0;stateD_bit < 4;stateD_bit ++)//״̬Ĵλѭ
						{
							if((stateReg[c_ic].uvOvFlags[stateD_byte] & (0x01 << (stateD_bit * 0x2U))) == (0x01 << stateD_bit * 0x2U))//жϸCellxǷѹ־λǷΪ1
								stateReg[c_ic].cellUvFlag |= 0x0001 << ((stateD_byte * 0x4U) + stateD_bit);//CellxǷѹ־λ1
							else
								stateReg[c_ic].cellUvFlag &= ~(0x0001 << ((stateD_byte * 0x4U) + stateD_bit));//CellxǷѹ־λ0
							
							if((stateReg[c_ic].uvOvFlags[stateD_byte] & (0x01 << (stateD_bit * 0x2U + 0x1U))) == (0x01 << (stateD_bit * 0x2U + 0x1U)))//жϸCellxĹѹ־λǷΪ1
								stateReg[c_ic].cellOvFlag |= 0x0001 << ((stateD_byte * 0x4U) + stateD_bit);//CellxĹѹ־λ1
							else
								stateReg[c_ic].cellOvFlag &= ~(0x0001 << ((stateD_byte * 0x4U) + stateD_bit));//CellxĹѹ־λ0
						}
					}
      }
      received_pec = (dataPtr[data_counter]<<8)+ dataPtr[data_counter+1];//The received PEC for the current_ic is transmitted as the 7th and 8th after the 6 gpio voltage data bytes
																		                                     //(յļɵ·ļΪ6GPIOѹֽ֮ĵ7͵8ֽڷ)
      data_pec = pec15_calc(BYT_IN_REG, &dataPtr[current_ic*NUM_RX_BYT]);//ջļĴ(68λĴ)еPEC()
      if (received_pec != data_pec)//Ƿƥ
      {
        pec_error = 1;//κPEC()pec_error򵥵Ϊ1
        stateReg[c_ic].pec_match[reg-1]=1;//stateReg[c_ic].pec_match[stat_reg-1]еļֵ1   
      }
      data_counter = data_counter + 2;//Because the transmitted PEC code is 2 bytes long the data_counter must be incremented by 2 bytes to point to the next ICs state voltage data
																		  //(ΪPEC()2ֽڳݼ2ֽڲָһɵ·״̬ѹ)
		}
  }
  free(dataPtr);//ָ
  return (pec_error);//شֵ
}

/*!
    \brief      Clear Cell Register(صѹĴ)
		\param[in]  none
    \retval     none
*/
void BF8915A_clrcell(void)
{
  uint8_t cmd[2]= {0x00 , 0x81};
  BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      Clear GPIO Register(GPIOĴ)
		\param[in]  none
    \retval     none
*/
void BF8915A_clrgp(void)
{
  uint8_t cmd[2]= {0x00 , 0x82};
  BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      Clear STATE Register(״̬Ĵ)
		\param[in]  none
    \retval     none
*/
void BF8915A_clrstat(void)
{
  uint8_t cmd[2]= {0x00 , 0x83};
  BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}

/*!
    \brief      PLADC CMD(ѯADCת״ָ̬)
		\param[in]  none
    \retval     none
*/
uint8_t BF8915A_pladc(void)
{
	uint8_t cmd[4];//ʼcmd[]
  uint8_t adc_state = 0xFF;//ʼadc_state
  uint16_t cmd_pec;//ָPEC()

  cmd[0] = 0x00;//ָĸ8λ
  cmd[1] = 0x84;//ָĵ8λ
  cmd_pec = pec15_calc(2, cmd);//ָPEC()
  cmd[2] = (uint8_t)(cmd_pec >> 8);//ָPEC()ĸ߰λ
  cmd[3] = (uint8_t)(cmd_pec);//ָPEC()ĵͰλ
	
		if (isospi_reverse == FALSE)//жѡľջͨŷԷ
    {
	    cs_low();//ƬѡCSΪ͵ƽ
      spi_write_array(4,cmd);//ֽдSPI˿
      adc_state = SPI1_ReadWriteByte(0xFF);//SPIյ
	    if(adc_state == 0xff)
	    {
	    	cs_high();//ƬѡCSΪߵƽ
	    }
    }
    else
    {
	    cs_low_reverse();//ƬѡCSΪ͵ƽ			
			spi_write_array(4,cmd);//ֽдSPI˿
      adc_state = SPI2_ReadWriteByte(0xFF);//SPIյ
	    if(adc_state == 0xff)
	    {
	      cs_high_reverse();//ƬѡCSΪߵƽ
	    }
    }
  return(adc_state);//شSPIյ
}

/*!
    \brief      soft reset(λ)
		\param[in]  none
    \retval     none
*/
void BF8915A_softrst(void)
{
  uint8_t cmd[2]= {0x00 , 0x55};
  BF8915A_cmd(cmd);//дBF8915AͨúΪcmdݼ˼
}
